/*
RtBOt@CǂݏW[
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#ifdef __DJGPP
#include <unistd.h>
#else
#include <io.h>
#endif
#include <sys/stat.h>
#include "cfgfile.h"

static char *Get_val_ptr(char *section, char *name);
void Cfgfile_exit();

bool Cannot_create_ini_flag = 0;
bool section_name_not_exist_flag = 0;
bool NoValue_flag = 0;

static char *Memory_loaded_config_data = 0;
static int Config_data_memory_size;
static char Section_str[256];
static char Name_str[256];
static int Section_str_len;
static int Name_str_len;
static char *tmp_charPtr;
static int strlength;
static void (*Cfgfile_exit_func)() = 0;
static char Config_filename[1024];
static FILE *fp;
static char intstr[20];
static bool exit_func_added_flag = 0;

bool Config_file_load(char *filename, void (*exitfunc)())
{
    struct stat Stat;
    /* t@C݂ȂꍇI */
    if(access(filename, 0))
        return 1;
    if(strlen(filename) >= 1024)
        return 1;
    strcpy(Config_filename, filename);
    /* t@CTCY擾 */
    stat(filename, &Stat);
    /* RtBOf[^i[pTCYݒ */
    Config_data_memory_size = Stat.st_size + 1;
    if(Memory_loaded_config_data)
        free(Memory_loaded_config_data);
    if(!(Memory_loaded_config_data = (char *)calloc(Config_data_memory_size, sizeof(char))))
        return 1;
    fp = fopen(filename, "r");
    fread(Memory_loaded_config_data, sizeof(char), Config_data_memory_size, fp);
    fclose(fp);
    Cfgfile_exit_func = exitfunc;
    if(exitfunc && !exit_func_added_flag) {
        atexit(Cfgfile_exit);
        exit_func_added_flag = 1;
    }
    return 0;
}

char *Get_val_string(char *section, char *name)
{
    static char string[1024];
    string[0] = 0;
    if(!Memory_loaded_config_data || !(tmp_charPtr = Get_val_ptr(section, name))) {
        NoValue_flag = 1;
        return string;
    }
    for(strlength = 0; tmp_charPtr[strlength] != '\n' && tmp_charPtr[strlength] != 0;
        strlength++);
    if(!strlength || strlength >= 1024) {
        NoValue_flag = 1;
        return string;
    }
    memmove(string, tmp_charPtr, strlength);
    string[strlength] = 0;
    NoValue_flag = 0;
    return string;
}

int Get_val_int(int previos, char *section, char *name)
{
    tmp_charPtr = Get_val_string(section, name);
    if(!(*tmp_charPtr) || !(isdigit(*tmp_charPtr))) {
        NoValue_flag = 1;
        return previos;
    }
    return (atoi(tmp_charPtr));
}

bool Set_val_int(char *section, char *name, int val)
{
    itoa(val, intstr, 10);
    return (Set_val_string(section, name, intstr));
}

bool Set_val_string(char *section, char *name, char *val)
{
    int Old_val_length;
    int New_val_length;
    int Val_ptr_ofs;
    int Move_back_size;
    if(!Memory_loaded_config_data || !(tmp_charPtr = Get_val_ptr(section, name)))
        return 1;
    Val_ptr_ofs = tmp_charPtr - Memory_loaded_config_data;
    for(strlength = 0; tmp_charPtr[strlength] != '\n' && tmp_charPtr[strlength] != 0;
        strlength++);
    Old_val_length = strlength;
    New_val_length = strlen(val);
    Move_back_size = Config_data_memory_size - (Val_ptr_ofs + Old_val_length);

    /* Old value 폜 */
    if(Old_val_length)
        memmove(tmp_charPtr, tmp_charPtr + Old_val_length,
                Move_back_size);
    if(Old_val_length != New_val_length)
        Memory_loaded_config_data = (char *)realloc(Memory_loaded_config_data, Config_data_memory_size - Old_val_length + New_val_length);
    if(!Memory_loaded_config_data)
        return 1;
    tmp_charPtr = Memory_loaded_config_data + Val_ptr_ofs;
    if(New_val_length) {
        memmove(tmp_charPtr + New_val_length,tmp_charPtr,
                Move_back_size);
        memmove(tmp_charPtr, val, New_val_length);
    }
    return 0;
}

static char *Get_val_ptr(char *section, char *name)
{
    char *section_start;
    char *section_end;
    Section_str_len = strlen(section) + 4;
    Name_str_len = strlen(name) + 4;
    if(255 < Section_str_len || 255 < Name_str_len) {
        section_name_not_exist_flag = 1;
        return 0;
    }
    /* "[section]"  */
    Section_str[0] = '\n';
    Section_str[1] = '[';
    strcpy(&Section_str[2], section);
    strcat(Section_str, "]\n");
    
    /* "name = "  */
    Name_str[0] = '\n';
    strcpy(&Name_str[1], name);
    strcat(Name_str, " = ");
    
    /* [section] ̉sʒuT */
    tmp_charPtr = strstr(Memory_loaded_config_data, Section_str);
    if(!tmp_charPtr) {
        section_name_not_exist_flag = 1;
        return 0;
    }
    section_start = tmp_charPtr + Section_str_len - 1;

    /* [section] ỎsʒuA܂inif[^̍Ō̃oCgʒuT */
    tmp_charPtr = strstr(section_start, "\n[");
    if(!tmp_charPtr)
        section_end = Memory_loaded_config_data + strlen(Memory_loaded_config_data) - 1;
    else
        section_end = tmp_charPtr;

    /* [section] ͈͓"name = " T */
    tmp_charPtr = strstr(section_start, Name_str);
    if(!tmp_charPtr || section_end < tmp_charPtr) {
        section_name_not_exist_flag = 1;
        return 0;
    }
    return (tmp_charPtr + Name_str_len);
}

void Cfgfile_exit()
{
    if(!Cannot_create_ini_flag && Memory_loaded_config_data
        && (fp = fopen(Config_filename, "w"))) {
        if(Cfgfile_exit_func)
            Cfgfile_exit_func();
        fprintf(fp, Memory_loaded_config_data);
        free(Memory_loaded_config_data);
        fclose(fp);
    }
    else if(Memory_loaded_config_data)
        free(Memory_loaded_config_data);
}

