/*********************************************************************************************/
/*                                                                                           */
/*********************************************************************************************/

#include "../snes9x.h"
#include "../memmap.h"
#include "../ppu.h"
#include "../display.h"
#include "../apu.h"
#include "../soundux.h"
#include "../snapshot.h"

void XPP_REPLAY_LOAD ()
{
 	STREAM f_replay;
 	if ((f_replay = OPEN_STREAM (S9xGetFilename (".rpa"), "rb")))
 	{
 	 	READ_STREAM (XppMovie.REPLAY_RAM, 0x400000, f_replay);
 	 	CLOSE_STREAM(f_replay);
 	}
}

void XPP_REPLAY_SAVE ()
{
 	STREAM f_replay;
 	if ((f_replay = OPEN_STREAM (S9xGetFilename (".rpa"), "wb")))
 	{
	 	WRITE_STREAM (XppMovie.REPLAY_RAM, 0x400000, f_replay);
	 	CLOSE_STREAM(f_replay);
 	}
}

#define REPLAY_COUNT_ADD_SKIP 0x10
#define REPLAY_DATA_TOTAL (14)
#define REPLAY_SAME_ADD (0xe)

void REPLAY_BYTE_SET ()
{
   XppMovie.replay_data[0] = Memory.FillRAM[0x4218];
   XppMovie.replay_data[1] = Memory.FillRAM[0x4219];
   XppMovie.replay_data[2] = Memory.FillRAM[0x421a];
   XppMovie.replay_data[3] = Memory.FillRAM[0x421b];
   XppMovie.replay_data[4] = Memory.FillRAM[0x421c];
   XppMovie.replay_data[5] = Memory.FillRAM[0x421d];
   XppMovie.replay_data[6] = Memory.FillRAM[0x421e];
   XppMovie.replay_data[7] = Memory.FillRAM[0x421f];

   XppMovie.replay_data[8] = XppMovie.replay_data_dummy;
   XppMovie.replay_data[9] = XppMovie.replay_data_dummy;
   XppMovie.replay_data[10] = XppMovie.replay_data_dummy;
   XppMovie.replay_data[11] = XppMovie.replay_data_dummy;
   XppMovie.replay_data[12] = XppMovie.replay_data_dummy;
   XppMovie.replay_data[13] = XppMovie.replay_data_dummy;

//   XppMovie.replay_data[**] = (uint8)(XppMovie.replay_data_dummy);
//   XppMovie.replay_data[**] = (uint8)(XppMovie.replay_data_dummy >> 8);

}

void REPLAY_BYTE_GET ()
{
   Memory.FillRAM[0x4218] = XppMovie.replay_data[0];
   Memory.FillRAM[0x4219] = XppMovie.replay_data[1];
   Memory.FillRAM[0x421a] = XppMovie.replay_data[2];
   Memory.FillRAM[0x421b] = XppMovie.replay_data[3];
   Memory.FillRAM[0x421c] = XppMovie.replay_data[4];
   Memory.FillRAM[0x421d] = XppMovie.replay_data[5];
   Memory.FillRAM[0x421e] = XppMovie.replay_data[6];
   Memory.FillRAM[0x421f] = XppMovie.replay_data[7];

   XppMovie.replay_data_dummy = XppMovie.replay_data[8];
   XppMovie.replay_data_dummy = XppMovie.replay_data[9];
   XppMovie.replay_data_dummy = XppMovie.replay_data[10];
   XppMovie.replay_data_dummy = XppMovie.replay_data[11];
   XppMovie.replay_data_dummy = XppMovie.replay_data[12];
   XppMovie.replay_data_dummy = XppMovie.replay_data[13];

//   XppMovie.replay_data_dummy = XppMovie.replay_data[**] + (XppMovie.replay_data[**] << 8);

}

#define REPLAY_RECODE_A_MACRO \
for (int i = 0; i < REPLAY_DATA_TOTAL; i += 1) \
{ \
  XppMovie.REPLAY_RAM[XppMovie.REPLAY_RAM_COUNT+i] = XppMovie.replay_data_temp [i] = XppMovie.replay_data[i]; \
}

#define REPLAY_RECODE_B_MACRO \
for (int i = 0; i < REPLAY_DATA_TOTAL; i += 1) \
{ \
  if(XppMovie.replay_data_temp [i] != XppMovie.replay_data[i]) change_byte = true; \
}

#define REPLAY_RECODE_C_MACRO \
XppMovie.REPLAY_RAM[XppMovie.REPLAY_RAM_COUNT+REPLAY_SAME_ADD] = (uint8)(XppMovie.replay_data_count); \
XppMovie.REPLAY_RAM[XppMovie.REPLAY_RAM_COUNT+REPLAY_SAME_ADD+1] = (uint8)(XppMovie.replay_data_count >> 8);

#define REPLAY_PLAY_A_MACRO \
for (int i = 0; i < REPLAY_DATA_TOTAL; i += 1) \
{ \
  XppMovie.replay_data[i] = XppMovie.replay_data_temp [i] = XppMovie.REPLAY_RAM[XppMovie.REPLAY_RAM_COUNT+i]; \
}

#define REPLAY_PLAY_B_MACRO \
for (int i = 0; i < REPLAY_DATA_TOTAL; i += 1) \
{ \
  XppMovie.replay_data[i] = XppMovie.replay_data_temp [i]; \
}

#define REPLAY_PLAY_C_MACRO \
XppMovie.replay_data_count  = ((XppMovie.REPLAY_RAM[XppMovie.REPLAY_RAM_COUNT+REPLAY_SAME_ADD]) + \
                                (XppMovie.REPLAY_RAM[XppMovie.REPLAY_RAM_COUNT+REPLAY_SAME_ADD+1] << 8));

void XPP_REPLAY_START ()
{
   if(XppMovie.Replay_rec == TRUE)
   {
      bool8 change_byte = false;

      REPLAY_BYTE_SET ();
      REPLAY_RECODE_B_MACRO

      if(XppMovie.Replay_count == 0)
      {
	   ZeroMemory (XppMovie.REPLAY_RAM, 0x400000);
	   for (int i = 0; i < REPLAY_DATA_TOTAL; i += 1)
	   {
                XppMovie.replay_data_temp [i]=0;
	   }
	   XppMovie.replay_data_count = 0;
      }
      else
      if(XppMovie.Replay_count == 1)
      {
	   REPLAY_RECODE_A_MACRO
	   XppMovie.replay_data_count = 0;
      }
      else
      if(XppMovie.replay_data_count > 0xFFFF || change_byte)
      {
	   XppMovie.replay_data_count  -= 1;
	   REPLAY_RECODE_C_MACRO

	   XppMovie.REPLAY_RAM_COUNT += REPLAY_COUNT_ADD_SKIP;

	   REPLAY_RECODE_A_MACRO
	   XppMovie.replay_data_count = 0;
      }

      XppMovie.replay_data_count += 1;
      XppMovie.Replay_count += 1;

      if(XppMovie.REPLAY_RAM_COUNT > 0x3fff00) XPP_REPLAY_END ();
   }
   else
   if(XppMovie.Replay_play == true)
   {
	XppMovie.REPLAY_RAM_COUNT_MAX = XppMovie.REPLAY_RAM[0x3FFFFD]
	 + (XppMovie.REPLAY_RAM[0x3FFFFE] << 8)
	 + (XppMovie.REPLAY_RAM[0x3FFFFF] << 16);

      if(XppMovie.Replay_count == 0)
      {
	   XppMovie.replay_data_count = 0;
      }
      else
      if(XppMovie.replay_data_count == 0)
      {
	   REPLAY_PLAY_A_MACRO
	   REPLAY_PLAY_C_MACRO
	   XppMovie.REPLAY_RAM_COUNT += REPLAY_COUNT_ADD_SKIP;
      }
      else
      {
	   REPLAY_PLAY_B_MACRO
	   XppMovie.replay_data_count  -= 1;
      }

      REPLAY_BYTE_GET ();

      XppMovie.Replay_count += 1;

      if(XppMovie.REPLAY_RAM_COUNT_MAX < XppMovie.REPLAY_RAM_COUNT)
      {
	   XPP_REPLAY_END ();
	   GFX.InfoStringTimeout = 100;
	   GFX.InfoString=("Movie Play Finished");
      }
   }

}

void XPP_REPLAY_END ()
{
   if(XppMovie.Replay_rec == true)
   {
      REPLAY_BYTE_SET ();

      REPLAY_RECODE_A_MACRO
      REPLAY_RECODE_C_MACRO

      XppMovie.REPLAY_RAM[0x3FFFF8] = (uint8)(XppMovie.Replay_count);
      XppMovie.REPLAY_RAM[0x3FFFF9] = (uint8)(XppMovie.Replay_count >> 8);
      XppMovie.REPLAY_RAM[0x3FFFFA] = (uint8)(XppMovie.Replay_count >> 16);
      XppMovie.REPLAY_RAM[0x3FFFFB] = (uint8)(XppMovie.Replay_count >> 24);

      XppMovie.REPLAY_RAM[0x3FFFFD] = (uint8)(XppMovie.REPLAY_RAM_COUNT);
      XppMovie.REPLAY_RAM[0x3FFFFE] = (uint8)(XppMovie.REPLAY_RAM_COUNT >> 8);
      XppMovie.REPLAY_RAM[0x3FFFFF] = (uint8)(XppMovie.REPLAY_RAM_COUNT >> 16);

      XPP_REPLAY_SAVE ();

      XppMovie.Replay_rec = false;
      XppMovie.Replay_count = 0;
      XppMovie.replay_data_count = 0;
      XppMovie.REPLAY_RAM_COUNT_MAX = 0;
      XppMovie.REPLAY_RAM_COUNT = 0;
   }
   else
   if(XppMovie.Replay_play == true)
   {
      XppMovie.Replay_play = false;
      XppMovie.Replay_count = 0;
      XppMovie.replay_data_count = 0;
      XppMovie.REPLAY_RAM_COUNT_MAX = 0;
      XppMovie.REPLAY_RAM_COUNT = 0;
   }
}
