
#if !defined(DIRECTX_H_INCLUDED)
#define DIRECTX_H_INCLUDED

#include <ddraw.h>
#include <dsound.h>
#include <dinput.h>

struct SDirectX
{
	HWND  hWnd;
	DWORD dwStyleWindowed;
	DWORD dwStyleFullScreen;

	LPDIRECTSOUND lpDS;
	LPDIRECTSOUNDBUFFER lpDSB;
	LPDIRECTSOUNDBUFFER lpDSBPrimary;

	bool DSAvailable;
	unsigned char DIuse;

	WAVEFORMATEX wfx;

	HRESULT dErr;
	LPDIRECTDRAW lpDD;
	LPDIRECTDRAWCLIPPER lpDDClipper;
	LPDIRECTDRAWPALETTE lpDDPalette;

	LPDIRECTDRAWSURFACE lpDDSPrimary;
	LPDIRECTDRAWSURFACE lpDDSBack;
	LPDIRECTDRAWSURFACE lpDDSOffScreen;

	LPDIRECTDRAWSURFACE2 lpDDSPrimary2;
	LPDIRECTDRAWSURFACE2 lpDDSBack2;
	LPDIRECTDRAWSURFACE2 lpDDSOffScreen2;
	LPDIRECTINPUT lpDI;
	int Width, Height;
	char Depth;
	unsigned char Windowed;
	unsigned char NeedClipper;
	unsigned char ForceClipper;
	unsigned char ForceWindowedDirectDrawClipper;
	unsigned char DisableHardwareScale;
	bool DoubleBuffered, OffScreenVRAM, BackBufferVRAM, wait_for_vsync;
	
	DDPIXELFORMAT DDPixelFormat;
};

//DirectX proc
extern bool DirectX_SetSoundMode(void);
extern bool DirectX_SetDisplayMode(int pWidth, int pHeight, char pDepth, unsigned char pWindowed, bool pDoubleBuffered);
extern void DirectX_Initialize0();
extern bool DirectX_Initialize(HWND hWnd, DWORD dwStyleWindowed, DWORD dwStyleFullScreen);
extern void DirectX_DeInitialize();
extern void DirectX_ClearPrimarySurface();
extern void DirectX_ClearOffscreenSurface();
extern void DirectX_ClearBackbufferSurface();
extern void DirectX_SetClipper(unsigned char clipflag, long dWidth, long dHeight);
extern bool DirectX_DirectInputInitialize();
extern void DirectX_DirectInputDeInitialize();

/*****************
 default settings
*****************/
extern bool DirectX_OffScreenVRAM_def;
extern bool DirectX_BackBufferVRAM_def;
extern bool DirectX_wait_for_vsync_def;
extern unsigned char DirectX_DIuse_def;
extern unsigned char DirectX_DisableHardwareScale_def;

//DirectX struct
extern struct SDirectX DirectX;

struct DDisplayMode {
	int Width;
	int Height;
	char Depth;
};
#endif // !defined(DIRECTX_H_INCLUDED)
