
#define NUM_JOYSTICKS 4

struct SJoypad {
	BOOL Enabled;
	WORD Left;
	WORD Left_Up;
	WORD Left_Down;
	WORD Right;
	WORD Right_Up;
	WORD Right_Down;
	WORD Up;
	WORD Down;
	WORD Start;
	WORD Select;
	WORD A;
	WORD B;
	WORD X;
	WORD Y;
	WORD L;
	WORD R;
	BOOL Turbo_Left;
	BOOL Turbo_Right;
	BOOL Turbo_Up;
	BOOL Turbo_Down;
	BOOL Turbo_Start;
	BOOL Turbo_Select;
	BOOL Turbo_A;
	BOOL Turbo_B;
	BOOL Turbo_X;
	BOOL Turbo_Y;
	BOOL Turbo_L;
	BOOL Turbo_R;
};

struct SJoyState{
	bool Left;
	bool Right;
	bool Up;
	bool Down;
	bool PovLeft;
	bool PovRight;
	bool PovUp;
	bool PovDown;
	bool ZUp;
	bool ZDown;
	bool RUp;
	bool RDown;
	bool UUp;
	bool UDown;
	bool VUp;
	bool VDown;
	bool Button[32];
};

struct mmJoystickInfo
{
	BOOL        m_bUseJoystick;
	UINT        m_uJoyID;

	JOYINFOEX   m_JoyInfo;
	JOYCAPS     m_JoyCaps;

	UINT        m_nDeadZone;
	DWORD       m_dwXDZmin;
	DWORD       m_dwXDZmax;
	DWORD       m_dwYDZmin;
	DWORD       m_dwYDZmax;
	DWORD       m_dwZDZmin;
	DWORD       m_dwZDZmax;
	DWORD       m_dwRDZmin;
	DWORD       m_dwRDZmax;
	DWORD       m_dwUDZmin;
	DWORD       m_dwUDZmax;
	DWORD       m_dwVDZmin;
	DWORD       m_dwVDZmax;

	double      m_dXScale;
	double      m_dYScale;
	struct SJoyState JoyState;
};

struct mmJoystick_private
{
	UINT                    m_nNumJoysticks;
	struct mmJoystickInfo    m_Joy[NUM_JOYSTICKS];
};

#define MAX_PHYSICAL_JOYSTICKS 20
#define MAX_AXES 20

typedef struct
{
	GUID guid;
	int offset;
} axis_type;

typedef struct
{
	BOOL use_joystick;
	GUID guidDevice;
	LPDIRECTINPUTDEVICE2 did;
	DWORD num_axes;
	axis_type axes[MAX_AXES];
	DWORD num_pov;
	DWORD num_buttons;
	DIJOYSTATE dijs;
	struct SJoyState JoyState;
} dijoystick_type;

struct diJoystick_private
{
	DWORD num_joysticks;
	dijoystick_type joysticks[MAX_PHYSICAL_JOYSTICKS];
};

struct diKeyboard_private
{
	LPDIRECTINPUTDEVICE  m_didKeyboard;
	byte m_key[256];
};

struct diMouse_private
{
	LPDIRECTINPUTDEVICE  m_didMouse;
	DIMOUSESTATE dims;
};

extern struct SJoypad Joypad[5];
extern DWORD MapFunc[];
extern void MakeTurboStatus();
extern void S9xwJoystickInit();
extern void DirectInput_exit();
extern struct diMouse_private diMouse;
extern WORD (*GetJoyButtonCode)();

#define MF_SAVE1 0
#define MF_SAVE2 1
#define MF_SAVE3 2
#define MF_SAVE4 3
#define MF_SAVE5 4
#define MF_LOAD1 5
#define MF_LOAD2 6
#define MF_LOAD3 7
#define MF_LOAD4 8
#define MF_LOAD5 9
#define MF_TURBO 10
#define MF_TURBOPAUSEFWD 11
#define MF_RESET 12
#define MF_SOFTRESET 13
#define MF_SPCDUMP 14
#define MF_SCREENSHOT 15

#define MF_XPP01 16
#define MF_XPP02 17
#define MF_XPP03 18
#define MF_XPP04 19
#define MF_XPP05 20
#define MF_XPP06 21
#define MF_XPP07 22
#define MF_XPP08 23
#define MF_XPP09 24
#define MF_SSTURBO 25
#define MF_SSPAUSE 26




