/*****************************************************************************/
/*  Snes9X: Win32                                                            */
/*****************************************************************************/
#include "../snes9x/memmap.h"
#include "../snes9x/cheats.h"
#include "directx.h"
#include "render.h"
#include "../snes9x/apu.h"
#include "../snes9x/cpuexec.h"
#include "s9xwproc.h"
#include "winutil.h"
#include "s9xutil.h"
#include "spcplay.h"
#include "../common/commutil.h"
#include "joywin.h"

#include <windows.h>
#include <shellapi.h>

/*****************************************************************************/
/* Snes9x proc extern                                                        */
/*****************************************************************************/
extern "C" void S9xMainLoop(void);
extern "C" void S9xSetInfoString (const char *string);
extern bool8 S9xSetSoundMute (bool8 mute);
extern bool8 S9xGraphicsInit ();
extern void S9xGraphicsDeinit (void);
extern "C" const char *S9xGetSRAMFilename ();
extern "C" const char *S9xBasename (const char *f);
extern "C" const char *S9xGetFilename (const char *e);
extern "C" void S9xNextController ();
extern void MakeTurboStatus();
extern int superscope_turbo;
extern int superscope_pause;

/*****************************************************************************/
/* Snes9XW proc extern                                                        */
/*****************************************************************************/
extern void S9xSetWinPixelFormat ();

/*****************************************************************************/
/* Xpp proc extern                                                       */
/*****************************************************************************/
extern void S9xSoftReset (void);

/*****************************************************************************/
/* uosnes proc extern                                                     */
/*****************************************************************************/
extern char *S9xwGetSPCFilename ();
extern char *S9xwGetSavedSPCNumberAndExtStr();
extern char *S9xwGetScreenImageFilename(char *ImageTypeExt);
extern char *S9xwGetSavedScreenImageNumberAndTypeStr();
extern bool InitSnes9X( void);
extern void DeinitSnes9X(void);
extern void ConfigDlgProp(HWND hWnd);
extern BOOL OpenFile(HWND hWnd, char *FileName, char *FileTitle, char *InitialROMFileDirectory);
extern BOOL OpenFileEx(HWND hWnd, char *FileName, char *FileTitle, char *InitialROMFileDirectory);
extern void S9xDrawScreenImage();

/*****************************************************************************/
/* Snes9XppW proc define                                                     */
/*****************************************************************************/
static bool ROMLoadProc(char *FileName);
void ScreenRedraw(HWND hWnd);
void Draw1frame();
void S9xwSetClipper(bool clip);
void S9xMessage2 (const char *str, int TimeOut);
void SetPriorityClassAndThreadPriority(DWORD priocl, int threadprio);

/*****************************************************************************/
/* Variables extern                                                          */
/*****************************************************************************/
extern bool8 locked_surface;
extern bool8 errConfigSwitch;

/*****************************************************************************/
/* Variables define                                                          */
/*****************************************************************************/
static void (*EmuExecLoop)(void);

/*****************************************************************************/
/* Global variables                                                          */
/*****************************************************************************/
extern "C" {
struct sGUI GUI;
};

#ifdef UNCO_FULL_TEAM
#ifdef UNCO_FULL_TEAM_2

char WindowTitleTextNormal_bak[] = "uosnes : Windows";
char WindowTitleTextNormal[] = "uosnes : Windows";
char WindowTitleTextPaused[] = "uosnes : - Paused";
char WindowTitleTextTurbo[] = "uosnes : - Turbo";
char WindowTitleText[256] = "uosnes : Windows";

#else

char WindowTitleTextNormal_bak[] = "uosnes : Windows";
char WindowTitleTextNormal[] = "uosnes : Windows";
char WindowTitleTextPaused[] = "uosnes : - Paused";
char WindowTitleTextTurbo[] = "uosnes : - Turbo";
char WindowTitleText[256] = "uosnes : Windows";

#endif

#else

char WindowTitleTextNormal_bak[] = "uosnes : Windows";
char WindowTitleTextNormal[] = "uosnes : Windows";
char WindowTitleTextPaused[] = "uosnes : - Paused";
char WindowTitleTextTurbo[] = "uosnes : - Turbo";
char WindowTitleText[256] = "uosnes : Windows";

#endif

bool Draw1FrameFlag = TRUE;
bool SPCPlayingFlag = FALSE;

static bool SPCLoadedFlag = FALSE;
static bool S9xwPauseLock = FALSE;
static bool S9xExitFlag = 0;

struct SSoundRates SoundRates[24] = {
	{  8000, false, false},
	{ 11025, false, false},
	{ 22050, false, false},
	{ 32000, false, false},
	{ 44100, false, false},
	{ 48000, false, false},
	{  8000, false, true },
	{ 11025, false, true },
	{ 22050, false, true },
	{ 32000, false, true },
	{ 44100, false, true },
	{ 48000, false, true },
	{  8000,  true, false},
	{ 11025,  true, false},
	{ 22050,  true, false},
	{ 32000,  true, false},
	{ 44100,  true, false},
	{ 48000,  true, false},
	{  8000,  true, true },
	{ 11025,  true, true },
	{ 22050,  true, true },
	{ 32000,  true, true },
	{ 44100,  true, true },
	{ 48000,  true, true }};

struct sLanguages Languages[] = {
	{ IDR_MENU_US, 
	  "DirectX failed to initialize!", 
	  "DirectDraw failed to set the selected display mode!", 
	  "DirectSound failed to initialize, no sound will be played.",
	  "These settings won't take effect until you restart the emulator.",
	  "The frame timer failed to initialize, please do NOT select the automatic framerate option or Snes9X will crash!",
	  "Anything error occured! Snes9XW shutdown.",
	  "Memory allocation error! Snes9XW shutdown.",
	  "Display Graphic mode settings failed! Snes9XW shutdown.",
	  "DirectInput failed to initialize, WinAPI will be used."},
	{ IDR_MENU_JP, 
	  "DirectX Ɏs܂", 
	  "DirectDraw fBXvC[hݒɎs܂", 
	  "DirectSound Ɏs܂",
	  "These settings won't take effect until you restart the emulator.",
	  "^C}[Ɏs܂Aframerate(ftHg)̐ݒősꍇ̓NbV܂",
	  "̃G[NSnes9XWI܂",
	  "mۂɎs܂AI܂",
	  "fBXvCAOtBbN[h؂芷Ɏs܂AI܂",
	  "DirectInputɎs܂AWinAPIgp܂"}
	};

static struct DDisplayMode DisplayMode [28] = {
	{ 256, 224, 8},
	{ 256, 224,16},
	{ 256, 240, 8},
	{ 256, 240,16},
	{ 320, 240, 8},
	{ 320, 240,16},
	{ 400, 300, 8},
	{ 400, 300,16},
	{ 512, 384, 8},
	{ 512, 384,16},
	{ 640, 400, 8},
	{ 640, 400,16},
	{ 512, 448, 8},
	{ 512, 448,16},
	{ 512, 478, 8},
	{ 512, 478,16},
	{ 640, 480, 8},
	{ 640, 480,16},
	{ 800, 600, 8},
	{ 800, 600,16},
	{1024, 768, 8},
	{1024, 768,16},
	{1152, 864, 8},
	{1152, 864,16},
	{1280, 1024, 8},
	{1280, 1024,16},
	{1600, 1200, 8},
	{1600, 1200,16}};

/*****************************************************************************/
/* uosnes Settings                                                        */
/*****************************************************************************/
bool8 SupportHiResFlag;
bool8 TransparencyFlag;
bool8 DoubleRendering = 0;
int DoubleRenderingModes16;
int DoubleRenderingModes8;
int FullscreenDisplayModeIndexNormal16 = 5;
int FullscreenDisplayModeIndexDouble16 = 17;
int FullscreenDisplayModeIndexDouble16_Stretch = 21;
int FullscreenDisplayModeIndexNormal8 = 4;
int FullscreenDisplayModeIndexDouble8 = 16;
int CurFullscreenDisplayModeIndex;
RECT WindowRectSetting = {-1, -1, -1, -1};

long DefaultWindowSizeW = 264 + 2;
long DefaultWindowSizeH = 286 + 1;

#define WinSizeWW (264+256 + 2)
#define WinSizeHH (286+239 + 1)
static long DefaultWindowSizeWW[7] = {WinSizeWW,WinSizeWW,WinSizeWW,WinSizeWW,WinSizeWW,WinSizeWW,WinSizeWW};
static long DefaultWindowSizeHH[7] = {WinSizeHH,WinSizeHH,WinSizeHH,WinSizeHH,WinSizeHH,WinSizeHH,WinSizeHH};

static long WindowSizeW = 264 + 2;
static long WindowSizeH = 286 + 1;

unsigned char dRendering;
unsigned char ForceWindowedDirectDrawClipper;

/*****************************************************************************/
/* Work variables                                                            */
/*****************************************************************************/
static HDC hdc;
static RECT rc;
static PAINTSTRUCT ps;
static HMENU hMenu;
static char tmpcharbuf[256];
static char OnScreenMessageStr[256] = {0};

/*****************************************************************************/
/* WinProc                                                                   */
/*****************************************************************************/

void ScreenBufferClear()
{
	extern BYTE ScreenBuffer[];
	extern BYTE SubScreenBuffer[];
	extern BYTE ZBuffer[];
	extern BYTE SubZBuffer[];
	extern unsigned char _2xSaI_Buffer[];
	extern unsigned char _2xSaI_TripleBuffer[];
	extern BYTE DepthConvertBuf[];

	FillMemory ((PVOID)ScreenBuffer, (512*478*2 + (512*3*2)), 0);
	FillMemory ((PVOID)SubScreenBuffer, 512*478*2, 0);
	FillMemory ((PVOID)ZBuffer, 512*478, 0);
	FillMemory ((PVOID)SubZBuffer, 512*478, 0);

	ZeroMemory( _2xSaI_Buffer, 512*478*2);
	ZeroMemory( _2xSaI_TripleBuffer, 512*478*2);
	ZeroMemory(DepthConvertBuf, 512*478*2);
	DirectX_ClearOffscreenSurface();

	//2xSaIATV[ĥ߂̃obt@NA΍
	ResetRenderMethod();
}

void CurFullscreenDisplayModeIndexChange()
{
	if(Settings.SixteenBit && DoubleRendering && GUI.Stretch)
		CurFullscreenDisplayModeIndex = FullscreenDisplayModeIndexDouble16_Stretch;
	else if(Settings.SixteenBit && DoubleRendering)
		CurFullscreenDisplayModeIndex = FullscreenDisplayModeIndexDouble16;
	else if(!Settings.SixteenBit && DoubleRendering)
		CurFullscreenDisplayModeIndex = FullscreenDisplayModeIndexDouble8;
	else if(Settings.SixteenBit && !DoubleRendering)
		CurFullscreenDisplayModeIndex = FullscreenDisplayModeIndexNormal16;
	else
		CurFullscreenDisplayModeIndex = FullscreenDisplayModeIndexNormal8;
}

char ROMFileName[_MAX_PATH] = {0};
static char FileTitle[_MAX_PATH] = {0};
char InitialROMFileDirectory[_MAX_PATH] = {0};
char RecentROMFileName[_MAX_PATH * 11] = {0};

unsigned char S9xwSwitchScreenMode(unsigned char Windowed)
{
	S9xwPauseLock = TRUE;
CurFullscreenDisplayModeIndexChange();
	if(!Windowed && DirectX.Windowed)
		SetWindowText(GUI.hWnd, WindowTitleText);
	if(!Windowed && GetMenu( GUI.hWnd) != NULL) {
		SetMenu( GUI.hWnd, NULL);
		GUI.AppMenuConnect = FALSE;
	}
	else if(Windowed && GetMenu( GUI.hWnd) == NULL) {
		SetMenu( GUI.hWnd, GUI.hMenu);
		GUI.AppMenuConnect = TRUE;
	}
	S9xGraphicsDeinit();

	if(!DirectX_SetDisplayMode(DisplayMode[CurFullscreenDisplayModeIndex].Width, DisplayMode[CurFullscreenDisplayModeIndex].Height, DisplayMode[CurFullscreenDisplayModeIndex].Depth, Windowed, GUI.DoubleBuffered) && !Windowed) {
		DirectX_SetDisplayMode(DisplayMode[CurFullscreenDisplayModeIndex].Width, DisplayMode[CurFullscreenDisplayModeIndex].Height, DisplayMode[CurFullscreenDisplayModeIndex].Depth, TRUE, GUI.DoubleBuffered);
		GUI.ScreenDepth = (DWORD)DirectX.Depth;
		GUI.FullScreen = !DirectX.Windowed;
		S9xSetWindowPos();
		SetWindowText(GUI.hWnd, WindowTitleText);
		MessageBox(GUI.hWnd, Languages[GUI.Language].errSwitchGFX, "Snes9X - Switch GFX mode", MB_OK | MB_ICONSTOP);
		S9xwSetMenuStatus(GUI.hMenu, GUI.hSysMenu);
		PostMessage( GUI.hWnd, WM_CLOSE, 0, 0);
		S9xwPauseLock = FALSE;
		return FALSE;
	}
	GUI.ScreenDepth = (DWORD)DirectX.Depth;

	S9xSetWinPixelFormat ();

	//؂芷s̃G[
	if(!S9xGraphicsInit())
	{
		S9xGraphicsDeinit();
		DirectX_SetDisplayMode(DisplayMode[CurFullscreenDisplayModeIndex].Width, DisplayMode[CurFullscreenDisplayModeIndex].Height, DisplayMode[CurFullscreenDisplayModeIndex].Depth, TRUE, GUI.DoubleBuffered);
		GUI.ScreenDepth = (DWORD)DirectX.Depth;
		GUI.FullScreen = !DirectX.Windowed;
		S9xSetWindowPos();
		SetWindowText(GUI.hWnd, WindowTitleText);
		MessageBox(GUI.hWnd, Languages[GUI.Language].errSwitchGFX, "Snes9X - Switch GFX mode", MB_OK | MB_ICONSTOP);
		S9xwSetMenuStatus(GUI.hMenu, GUI.hSysMenu);
		PostMessage( GUI.hWnd, WM_CLOSE, 0, 0);
		S9xwPauseLock = FALSE;
		return FALSE;
	}

	S9xInitUpdate ();

	if(!GUI.StopEmulation && !SPCPlayingFlag) {
		for (int c = 0; c < 256; c++)
			IPPU.ScreenColors [c] = c;
		S9xFixColourBrightness ();
		IPPU.ColorsChanged = TRUE;
		IPPU.RenderThisFrame = FALSE;
	}

	GUI.FullScreen = !DirectX.Windowed;

	//2xSaI[hXN[obt@NA΍
	ResetRenderMethod();

	if(DirectX.Windowed) {
		S9xSetInfoString ("");
		S9xSetWindowPos();
		SetWindowText(GUI.hWnd, WindowTitleText);
	}
	S9xwPauseLock = FALSE;
	//Erase mouse cursor.
	if(IPPU.Controller != SNES_SUPERSCOPE && IPPU.Controller != SNES_JUSTIFIER && !GUI.StopEmulation && !GUI.PauseEmulation && !SPCPlayingFlag)
		S9xMessage2 ("EraseMouseCursor", 1000);
	return TRUE;
}

bool8 SetupSound( long rate, bool8 sixteen_bit, bool8 stereo);
#include "../snes9x/ppu.h"
#include "../snes9x/snapshot.h"

void SwitchToGDI()
{
	IPPU.ColorsChanged = true;
	if( DirectX.lpDDSPrimary != NULL)
	{
		DirectX.lpDD -> FlipToGDISurface();
		DirectX.lpDDSPrimary -> SetPalette( NULL);
	}
	else
	{
		DirectX.lpDD -> FlipToGDISurface();
		DirectX.lpDDSPrimary2 -> SetPalette( NULL);
	}
}

void UpdateBackBuffer()
{
	if(DirectX.Windowed) {
		DirectX_ClearOffscreenSurface();
		ScreenRedraw(GUI.hWnd);
		return;
	}
	SwitchToGDI();
	DirectX_ClearPrimarySurface();
	DirectX_ClearBackbufferSurface();
}

//XN[bZ[W
static char S9xInfoString[256] = {0};
static char OnScreenMessage[256] = {0};
static char ExitMenuMessage[256] = {0};
static char MouseEraseMessage[256] = {0};
static DWORD OnScreenMessageTimeOut = 0;
static DWORD ExitMenuTimeOut = 0;
static DWORD MouseEraseTimeOut = 0;
static bool OnScreenMessageTimerActiveFlag = FALSE;
static bool8 MinimizedFlag = 0;
static bool ncbuttondown_flag = 0;
static bool WindowActiveFlag = 0;
static bool SizingFlag = 0;
void S9xwPauseEmulation(bool pause);

void S9xMessage2 (const char *str, int TimeOut)
{
	//ExitMenuMessageZbg
	if(!lstrcmp(str, "S9xwExitMenu")) {
		lstrcpy(ExitMenuMessage, str);
		ExitMenuTimeOut = timeGetTime() + TimeOut;
	}
	//MouseEraseMessageZbg
	else if(!lstrcmp(str, "EraseMouseCursor")) {
		lstrcpy(MouseEraseMessage, str);
		MouseEraseTimeOut = timeGetTime() + TimeOut;
	}
	//OnScreenMessageZbg
	else {
		lstrcpy(OnScreenMessage, str);
		OnScreenMessageTimeOut = timeGetTime() + TimeOut;
		if(DirectX.Windowed)
		{
			SetWindowText(GUI.hWnd, OnScreenMessage);
		}
	}
	//^C}[Zbg
	if(!OnScreenMessageTimerActiveFlag) {
		SetTimer(GUI.hWnd, 101, 100, NULL);
		OnScreenMessageTimerActiveFlag = TRUE;
	}
}

void OnScreenMessageUpdate()
{
	//ExitMenuMessage
	if(!lstrcmp(ExitMenuMessage, "S9xwExitMenu") && timeGetTime() > ExitMenuTimeOut) {
		if((!MinimizedFlag || SPCPlayingFlag) && !GUI.FullScreen && DirectX.Windowed && !GUI.PauseEmulation && WindowActiveFlag && !SizingFlag && !ncbuttondown_flag)
			S9xwPauseEmulation(FALSE);
		ExitMenuMessage[0] = 0;
		ExitMenuTimeOut = 0;
	}
	//MouseEraseMessage
	if(!lstrcmp(MouseEraseMessage, "EraseMouseCursor") && timeGetTime() > MouseEraseTimeOut) {
		if(IPPU.Controller != SNES_SUPERSCOPE && IPPU.Controller != SNES_JUSTIFIER && !GUI.StopEmulation && !GUI.ForcedPauseEmulation && !GUI.PauseEmulation && !SPCPlayingFlag)
			SetCursor(NULL);
		MouseEraseMessage[0] = 0;
		MouseEraseTimeOut = 0;
	}
	//OnScreenMessage
	if(OnScreenMessage[0] && timeGetTime() > OnScreenMessageTimeOut) {
		if(DirectX.Windowed)
		{
			SetWindowText(GUI.hWnd, WindowTitleText);
		}
		OnScreenMessage[0] = 0;
		OnScreenMessageTimeOut = 0;
	}
	if(!ExitMenuMessage[0] && !MouseEraseMessage[0] && !OnScreenMessage[0] && OnScreenMessageTimerActiveFlag) {
		KillTimer(GUI.hWnd, 101);
		OnScreenMessageTimerActiveFlag = FALSE;
	}
}

void S9xwKillMessageTimer()
{
	if(OnScreenMessageTimerActiveFlag) {
		KillTimer(GUI.hWnd, 101);
		OnScreenMessageTimerActiveFlag = FALSE;
	}
	if(DirectX.Windowed)
	{
		SetWindowText(GUI.hWnd, WindowTitleText);
	}
	ExitMenuMessage[0] = MouseEraseMessage[0] = OnScreenMessage[0] = 0;
	ExitMenuTimeOut = MouseEraseTimeOut = OnScreenMessageTimeOut = 0;
}

void S9xwSetClipper(bool clip)
{
	if(GUI.Stretch) {
		GetClientRect(GUI.hWnd, &rc);
		DirectX_SetClipper(clip, rc.right - rc.left, rc.bottom - rc.top);
		ResetRenderMethod();
		if(Draw1FrameFlag && clip)
			Draw1frame();
	}
	else {
		long dWidth, dHeight;
		dHeight = 239;
		dWidth = 256;
		if(GUI.Scale > 0)
			dHeight <<= 1;
		if(GUI.Scale > 0)
			dWidth <<= 1;
		DirectX_SetClipper(clip, dWidth, dHeight);
		ResetRenderMethod();
		if(Draw1FrameFlag && clip)
			Draw1frame();
	}
	ResetRenderMethod();
}

void S9xwPauseEmulation(bool pause)
{
	if(pause)
		S9xwKillMessageTimer();
	if((GUI.FullScreen && DirectX.Windowed) || GUI.PauseEmulation || S9xwPauseLock) {
		S9xSetSoundMute (TRUE);
		return;
	}
	if(SPCLoadedFlag && !pause) {
		Sleep(500);
		SPCLoadedFlag = FALSE;
	}
	GUI.ForcedPauseEmulation = pause;
	S9xSetSoundMute ((bool8)pause);

	S9xwSetClipper(pause);

	if(!pause && IPPU.Controller != SNES_SUPERSCOPE && IPPU.Controller != SNES_JUSTIFIER && !GUI.StopEmulation && !GUI.PauseEmulation && !SPCPlayingFlag)
		S9xMessage2 ("EraseMouseCursor", 1000);
}

bool UIEnter()
{
	S9xwPauseEmulation(TRUE);
	S9xwKillMessageTimer();
	if(GUI.FullScreen && !DirectX.Windowed) {
		S9xwPauseEmulation(TRUE);
		S9xwPauseLock = TRUE;
		if(S9xwSwitchScreenMode(TRUE)) {
			GUI.FullScreen = TRUE;
			S9xwSetClipper(TRUE);
			if(GUI.StopEmulation || SPCPlayingFlag)
				S9xDrawScreenImage();
			S9xwPauseLock = FALSE;
		}
		else
			return FALSE;
	}
	return TRUE;
}

void UIExit()
{
	if((DirectX.Windowed && !GUI.FullScreen) || (!DirectX.Windowed && GUI.FullScreen))
		S9xwPauseEmulation(FALSE);
}

void S9xwStateSave(char SaveSlotNum)
{
	if(GUI.StopEmulation || SPCPlayingFlag || (GUI.PauseEmulation && GUI.FullScreen))
		return;
	char saveext [_MAX_EXT];
	char savemesj[] = "Slot #1 saved";
	char savemese[] = "Slot #1 saved";
	bool8 saveerr;

	lstrcpy(saveext, ".000");

	saveext[3] = (0x30 + SaveSlotNum - 1);
	savemesj[6] = savemese[6] = (0x30 + SaveSlotNum);
	S9xwPauseEmulation(TRUE);
	saveerr = S9xFreezeGame(S9xGetFilename(saveext));
	if(GUI.PauseEmulation)
		S9xSetSoundMute (TRUE);
	else
		S9xwPauseEmulation(FALSE);
	if(saveerr)
		S9xMessage2 ((GUI.Language && DirectX.Windowed) ? savemesj : savemese, 2000);
	else
		S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "Error!" : "Error!", 2000);
}

void S9xwStateLoad(int SaveSlotNum)
{
	if(GUI.StopEmulation || SPCPlayingFlag || (GUI.PauseEmulation && GUI.FullScreen))
		return;
	char loadext [_MAX_EXT];
	char loadmesj[] = "Slot #1 loaded";
	char loadmese[] = "Slot #1 loaded";
	bool8 loaderr;

	lstrcpy(loadext, ".000");

	loadext[3] = (0x30 + SaveSlotNum - 1);
	loadmesj[6] = loadmese[6] = (0x30 + SaveSlotNum);

	S9xwPauseEmulation(TRUE);
	loaderr = S9xUnfreezeGame(S9xGetFilename(loadext));
	if(GUI.PauseEmulation)
		S9xSetSoundMute (TRUE);
	else
		S9xwPauseEmulation(FALSE);
	if(loaderr)
		S9xMessage2 ((GUI.Language && DirectX.Windowed) ? loadmesj : loadmese, 2000);
	else
		S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "Error!" : "Error!", 2000);
}

void S9xwStateSaveReplay()
{
	if(GUI.StopEmulation || SPCPlayingFlag || (GUI.PauseEmulation && GUI.FullScreen))
		return;
	bool8 saveerr;

	S9xwPauseEmulation(TRUE);
	saveerr = S9xFreezeGame(S9xGetFilename(".rpb"));
	if(GUI.PauseEmulation)
		S9xSetSoundMute (TRUE);
	else
		S9xwPauseEmulation(FALSE);

	if(saveerr)
        {
		S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "Movie Rec Start" : "Movie Rec Start", 2000);
        }
	else
        {
		S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "Error!" : "Error!", 2000);
	        XppMovie.Replay_play = false;
	        XppMovie.Replay_rec = false;
        }
}

void S9xwStateLoadReplay()
{
	if(GUI.StopEmulation || SPCPlayingFlag || (GUI.PauseEmulation && GUI.FullScreen))
		return;

	bool8 loaderr;
	S9xwPauseEmulation(TRUE);
	loaderr = S9xUnfreezeGame(S9xGetFilename(".rpb"));
	if(GUI.PauseEmulation)
		S9xSetSoundMute (TRUE);
	else
		S9xwPauseEmulation(FALSE);
	if(loaderr)
        {
		S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "Movie Play Start" : "Movie Play Start", 2000);
        }
	else
        {
		S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "Error!" : "Error!", 2000);
	        XppMovie.Replay_play = false;
	        XppMovie.Replay_rec = false;
        }
}


LRESULT CALLBACK WinProc(
	HWND hWnd,
	UINT uMsg,
	WPARAM wParam,
	LPARAM lParam)
{
static bool CmdLineROMLoadFlag = 0;
static bool NeedScreenImage = 1;
static bool NeedJoystickInit = 1;
static HDROP hDrop;
//static RECT SizingClip;
static HRGN hRgn1, hRgn2, hRgn3;
static long RedrawDstW, RedrawDstH;
static uint8 ErrResult;

	switch( uMsg)
	{
	case WM_CREATE:
		//inactivate IME
		ImeEnable(hWnd, FALSE);
		InitCommonControls();
		if(DoubleRendering) {
			GUI.Scale = (Settings.SixteenBit ? DoubleRenderingModes16 : DoubleRenderingModes8);
			Settings.SupportHiRes = SupportHiResFlag;
		}
		DragAcceptFiles(hWnd, TRUE); //hbOhbvݒ
		WindowActiveFlag = 1;
		if(!S9xExitFlag && __argc > 1) {
			//V[gt@COt@Cɕϊ
			if(GetLongFileName(__argv[1], ROMFileName, _MAX_PATH))
				CmdLineROMLoadFlag = 1;
		}
		if(S9xExitFlag) {
			MessageBox(GUI.hWnd, Languages[GUI.Language].errMemoryInit, "Snes9X - Memory Init", MB_OK | MB_ICONSTOP);
			PostMessage( hWnd, WM_CLOSE, 0, 0);
		}
		S9xwSetMenuStatus(GUI.hMenu, GUI.hSysMenu);
		break;

	//SNES}EXAX[p[XR[vpԎ擾
	case WM_LBUTTONDOWN:
		if((IPPU.Controller == SNES_MOUSE || IPPU.Controller == SNES_MOUSE_SWAPPED) && !GUI.StopEmulation && !GUI.ForcedPauseEmulation && !GUI.PauseEmulation && !SPCPlayingFlag)
			SetCursor(NULL);
		else {
			SetCursor(LoadCursor(NULL, IDC_ARROW));
			if(IPPU.Controller != SNES_SUPERSCOPE && IPPU.Controller != SNES_JUSTIFIER && !GUI.StopEmulation && !GUI.PauseEmulation && !SPCPlayingFlag) {
				S9xMessage2 ("EraseMouseCursor", 1000);
			}
		}
		GUI.MouseButtons |= 1;
		break;

	case WM_LBUTTONUP:
		GUI.MouseButtons &= 0xfffffffe;
		break;

	case WM_RBUTTONDOWN:
		if((IPPU.Controller == SNES_MOUSE || IPPU.Controller == SNES_MOUSE_SWAPPED) && !GUI.StopEmulation && !GUI.ForcedPauseEmulation && !GUI.PauseEmulation && !SPCPlayingFlag)
			SetCursor(NULL);
		else {
			SetCursor(LoadCursor(NULL, IDC_ARROW));
			if(IPPU.Controller != SNES_SUPERSCOPE && IPPU.Controller != SNES_JUSTIFIER && !GUI.StopEmulation && !GUI.PauseEmulation && !SPCPlayingFlag) {
				S9xMessage2 ("EraseMouseCursor", 1000);
			}
		}
		GUI.MouseButtons |= 2;
		break;

	case WM_RBUTTONUP:
		GUI.MouseButtons &= 0xfffffffd;
		break;

	case WM_MBUTTONDOWN:
		if((IPPU.Controller == SNES_MOUSE || IPPU.Controller == SNES_MOUSE_SWAPPED) && !GUI.StopEmulation && !GUI.ForcedPauseEmulation && !GUI.PauseEmulation && !SPCPlayingFlag)
			SetCursor(NULL);
		else {
			SetCursor(LoadCursor(NULL, IDC_ARROW));
			if(IPPU.Controller != SNES_SUPERSCOPE && IPPU.Controller != SNES_JUSTIFIER && !GUI.StopEmulation && !GUI.PauseEmulation && !SPCPlayingFlag) {
				S9xMessage2 ("EraseMouseCursor", 1000);
			}
		}
		GUI.MouseButtons |= 4;
		break;

	case WM_MBUTTONUP:
		GUI.MouseButtons &= 0xfffffffb;
		break;

	case WM_MOUSEMOVE:
            if (!GUI.IgnoreNextMouseMove)
            {
                POINT p;
                p.x = (int16) (lParam & 0xffff);
                p.y = (int16) ((lParam >> 16) & 0xffff);
                ClientToScreen (GUI.hWnd, &p);
                if ((!Settings.ForcedPause && !Settings.StopEmulation && 
                     !Settings.Paused && !SPCPlayingFlag) &&
                    (IPPU.Controller == SNES_MOUSE ||
                     IPPU.Controller == SNES_MOUSE_SWAPPED))
                {
                    POINT middle;
                    RECT size;
                    
                    GetClientRect (GUI.hWnd, &size);
                    middle.x = (size.right - size.left) >> 1;
                    middle.y = (size.bottom - size.top) >> 1;
                    ClientToScreen (GUI.hWnd, &middle);
                    GUI.MouseX += p.x - middle.x;
                    GUI.MouseY += p.y - middle.y;
                    SetCursorPos (middle.x, middle.y);
                    GUI.IgnoreNextMouseMove = TRUE;
                }
                else
                {
                    GUI.MouseX = p.x;
                    GUI.MouseY = p.y;
                }
            }
            else
                GUI.IgnoreNextMouseMove = FALSE;
		break;

	case WM_SETCURSOR:
		break;

	case WM_NCMOUSEMOVE:
		GUI.MouseButtons = 0;
		break;

	case WM_TIMER:
		if(!DirectX.Windowed && OnScreenMessage[0]) {
			lstrcpy(S9xInfoString, OnScreenMessage);
			S9xSetInfoString (S9xInfoString);
			OnScreenMessage[0] = 0;
			OnScreenMessageTimeOut = 0;
		}
		else if(OnScreenMessage[0] || ExitMenuMessage[0] || MouseEraseMessage[0])
			OnScreenMessageUpdate();
		break;

	case WM_EXITMENULOOP:
		S9xMessage2("S9xwExitMenu", 200);
		break;

	case WM_MOVE:
		break;

	case WM_MOVING:
		break;

	case WM_ACTIVATE:
		switch(LOWORD(wParam))
		{
			case WA_ACTIVE: case WA_CLICKACTIVE:
				WindowActiveFlag = 1;
				if(!GUI.StopEmulation)
					SetPriorityClassAndThreadPriority(GUI.PriorityClass, GUI.ThreadPriority);
				else
					SetPriorityClassAndThreadPriority(NORMAL_PRIORITY_CLASS, THREAD_PRIORITY_NORMAL);
				if(!GUI.FullScreen && DirectX.Windowed && !ncbuttondown_flag && !MinimizedFlag) {
					S9xwPauseEmulation(FALSE);
				}
				break;
			
			case WA_INACTIVE:
				WindowActiveFlag = 0;
				if(!SPCPlayingFlag) {
					SetPriorityClassAndThreadPriority(NORMAL_PRIORITY_CLASS, THREAD_PRIORITY_NORMAL);
					S9xwPauseEmulation(TRUE);
				}
				else if(MinimizedFlag)
					S9xwPauseEmulation(FALSE);
				break;

			default:
				break;
		}
		break;

/*
	case WM_ACTIVATEAPP:
		if(wParam && !GUI.FullScreen && DirectX.Windowed && !ncbuttondown_flag && !MinimizedFlag) {
			WindowActiveFlag = 1;
			S9xwPauseEmulation(FALSE);
		}
		else if(!wParam && !SPCPlayingFlag) {
			WindowActiveFlag = 0;
			S9xwPauseEmulation(TRUE);
		}
		break;
*/

	case WM_DROPFILES:
		/* hbOAhhbv */
		if(GUI.PauseEmulation)
			break;
		SetForegroundWindow(hWnd);
		hDrop=(HDROP)wParam;
		DragQueryFile(hDrop, 0, ROMFileName, _MAX_PATH);
		DragFinish(hDrop);
		S9xwPauseEmulation(TRUE);
		UpdateBackBuffer();
		ROMLoadProc(ROMFileName);
		if(!GUI.StopEmulation)
			SetPriorityClassAndThreadPriority(GUI.PriorityClass, GUI.ThreadPriority);
		else
			SetPriorityClassAndThreadPriority(NORMAL_PRIORITY_CLASS, THREAD_PRIORITY_NORMAL);
		S9xwPauseEmulation(FALSE);
		if(IPPU.Controller != SNES_SUPERSCOPE && IPPU.Controller != SNES_JUSTIFIER && !GUI.StopEmulation && !GUI.PauseEmulation && !SPCPlayingFlag)
			S9xMessage2 ("EraseMouseCursor", 1000);
		break;

	case WM_KEYDOWN:
		switch( wParam)
		{
		case VK_ESCAPE:
			//EChE[h
			if(DirectX.Windowed && !GUI.FullScreen) {
				if(GetMenu( GUI.hWnd) == NULL) {
					SetMenu( GUI.hWnd, GUI.hMenu);
					GUI.AppMenuConnect = TRUE;
					DrawMenuBar( GUI.hWnd);
				}
				else {
					SetMenu( GUI.hWnd, NULL);
					GUI.AppMenuConnect = FALSE;
				}
				GetClientRect(GUI.hWnd, &rc);
				hdc = GetDC(GUI.hWnd);
				FillRect(hdc, &rc, (HBRUSH)GetStockObject(BLACK_BRUSH));
				ReleaseDC(GUI.hWnd, hdc);
				S9xwSetMenuStatus(GUI.hMenu, GUI.hSysMenu);
				if(GUI.StopEmulation || SPCPlayingFlag)
					ScreenRedraw(hWnd);
			}
			//tXN[[h
			else if(!DirectX.Windowed && GUI.FullScreen) {
				S9xwPauseEmulation(TRUE);
				S9xwPauseLock = TRUE;
				if(S9xwSwitchScreenMode(TRUE)) {
					GUI.FullScreen = TRUE;
					S9xwSetClipper(TRUE);
					if(GUI.StopEmulation || SPCPlayingFlag)
						S9xDrawScreenImage();
					S9xwPauseLock = FALSE;
				}
				else
					break;
			}
			else if(DirectX.Windowed && GUI.FullScreen && !GUI.StopEmulation) {
				if(S9xwSwitchScreenMode(FALSE))
					S9xwPauseEmulation(FALSE);
				else
					break;
			}
			break;

		//State save load
		case VK_F1:
		case VK_F2:
		case VK_F3:
		case VK_F4:
		case VK_F5:
		case VK_F6:
		case VK_F7:
		case VK_F8:
		case VK_F9:
			if(GUI.StopEmulation || SPCPlayingFlag)
				break;
			//load
			if((GetKeyState(VK_SHIFT) & 0x8000) == 0) {
				wsprintf(tmpcharbuf, ".%03d", wParam - VK_F1);
				if(GetFileAttributes(S9xGetFilename(tmpcharbuf)) == 0xffffffff)
					break;
				S9xwStateLoad(wParam - VK_F1 + 1);
			}
			//save
			else {
				S9xwStateSave(wParam - VK_F1 + 1);
			}
			break;

		default:
			break;
		}
		break;

	case WM_SYSKEYUP:
		switch(wParam)
		{
			case VK_RETURN:
				if((DirectX.Windowed && DirectX.Depth == 8) || SPCPlayingFlag)
					break;
				S9xwPauseEmulation(TRUE);
				//tXN[[hŃEChEԂŃj[쒆cAǂݍłȂEChE[h
				if(GUI.FullScreen && DirectX.Windowed || (!GUI.FullScreen && DirectX.Windowed && GUI.StopEmulation))
					GUI.FullScreen = !GUI.FullScreen;
				//tXN[
				else if(!GUI.FullScreen && DirectX.Windowed && !GUI.StopEmulation) {
					if(!S9xwSwitchScreenMode(FALSE))
						break;
				}
				//EChE
				else if(GUI.FullScreen && !DirectX.Windowed && !GUI.StopEmulation) {
					if(!S9xwSwitchScreenMode(TRUE))
						break;
				}
				S9xwPauseEmulation(FALSE);
				break;

			default:
				break;
		}
		break;

	case WM_COMMAND:
		switch( LOWORD(wParam))
		{
		case ID_FILE_OPEN:
			if(GUI.PauseEmulation || !UIEnter())
				break;
			S9xwPauseEmulation(TRUE);
			S9xwPauseLock = TRUE;
			if ((GUI.FileBrowseWindow == 0 && OpenFile(hWnd, ROMFileName, FileTitle, InitialROMFileDirectory)) ||
				(GUI.FileBrowseWindow == 1 && OpenFileEx(hWnd, ROMFileName, FileTitle, InitialROMFileDirectory))) {
				UpdateBackBuffer();
				ROMLoadProc(ROMFileName);
				if(!GUI.StopEmulation)
					SetPriorityClassAndThreadPriority(GUI.PriorityClass, GUI.ThreadPriority);
				else
					SetPriorityClassAndThreadPriority(NORMAL_PRIORITY_CLASS, THREAD_PRIORITY_NORMAL);
			}
			S9xwPauseLock = FALSE;
			UIExit();
			if(IPPU.Controller != SNES_SUPERSCOPE && IPPU.Controller != SNES_JUSTIFIER && !GUI.StopEmulation && !GUI.PauseEmulation && !SPCPlayingFlag)
				S9xMessage2 ("EraseMouseCursor", 1000);
			break;

		case ID_FILE_RECENT1:
		case ID_FILE_RECENT2:
		case ID_FILE_RECENT3:
		case ID_FILE_RECENT4:
		case ID_FILE_RECENT5:
		case ID_FILE_RECENT6:
		case ID_FILE_RECENT7:
		case ID_FILE_RECENT8:
		case ID_FILE_RECENT9:
		case ID_FILE_RECENTA:
			if(GUI.PauseEmulation)
				break;
			UpdateBackBuffer();
			S9xwPauseEmulation(TRUE);
			ROMLoadProc(&RecentROMFileName[_MAX_PATH * (LOWORD(wParam) - ID_FILE_RECENT1)]);
			if(!GUI.StopEmulation)
				SetPriorityClassAndThreadPriority(GUI.PriorityClass, GUI.ThreadPriority);
			else
				SetPriorityClassAndThreadPriority(NORMAL_PRIORITY_CLASS, THREAD_PRIORITY_NORMAL);
			S9xwPauseEmulation(FALSE);
			break;

		case ID_FILE_RESET:
			if(GUI.StopEmulation || SPCPlayingFlag || GUI.PauseEmulation)
				break;
			S9xwPauseEmulation(TRUE);
			S9xReset();
// Original
if(Xppcdda.Enable) cdda_stop();

#ifdef UNCO_FULL_TEAM
if(Xppbsx.BsxRomCheck) {
BSX_CLEAR ();
BSX_TIMESET (); 
}
#endif
			ScreenBufferClear();
			if(GUI.FullScreen && DirectX.Windowed)
			{
				if(!S9xwSwitchScreenMode(FALSE))
					break;
			}
			else
				UpdateBackBuffer();
			S9xwPauseEmulation(FALSE);
			break;

		case ID_FILE_SOFTRESET:
			if(GUI.StopEmulation || SPCPlayingFlag || GUI.PauseEmulation)
				break;
			S9xwPauseEmulation(TRUE);
			S9xSoftReset();
// Original
if(Xppcdda.Enable) cdda_stop();

#ifdef UNCO_FULL_TEAM
if(Xppbsx.BsxRomCheck) {
BSX_CLEAR ();
BSX_TIMESET (); 
}
#endif
			ScreenBufferClear();
			if(GUI.FullScreen && DirectX.Windowed)
			{
				if(!S9xwSwitchScreenMode(FALSE))
					break;
			}
			else
				UpdateBackBuffer();
			S9xwPauseEmulation(FALSE);
			break;

		case ID_FILE_SPCDUMP:
#if 0
			{
				FILE *fp;
				fp = fopen("c:\\sagyoba\\xb.bin", "wb");
				if(!fp)
					break;
				fwrite(ROM, 1, 0x400000, fp);
				fclose(fp);
			}
			break;
#endif
			if(GUI.StopEmulation || SPCPlayingFlag || (GUI.PauseEmulation && GUI.FullScreen))
				break;
			ErrResult = S9xwSPCDump(S9xwGetSPCFilename(), (GUI.PauseEmulation || (GUI.FullScreen && DirectX.Windowed)) ? TRUE : FALSE);
			if(ErrResult) {
				lstrcpy(OnScreenMessageStr, S9xwGetSavedSPCNumberAndExtStr());
				lstrcat(OnScreenMessageStr, (GUI.Language && DirectX.Windowed) ? " Z[u" : " saved");
			}
			else
				lstrcpy(OnScreenMessageStr, (GUI.Language && DirectX.Windowed) ? "G[!" : "Error!");
			S9xMessage2 (OnScreenMessageStr, 2000);
/*
			extern unsigned char S9xScreenImageDump(char *scfile);
			S9xScreenImageDump(S9xwGetScreenImageFilename(".SC"));
*/
			break;

		case ID_FILE_ZSTSAVE:
			if(GUI.StopEmulation || SPCPlayingFlag || (GUI.PauseEmulation && GUI.FullScreen))
				break;
			{
				uint8 zstsaveerr;
				S9xwPauseEmulation(TRUE);
				extern bool8 S9xFreezeZSNES (const char *filename);
				zstsaveerr = S9xFreezeZSNES(S9xGetFilename(".zst"));
				if(GUI.PauseEmulation)
					S9xSetSoundMute (TRUE);
				else
					S9xwPauseEmulation(FALSE);
				if(zstsaveerr)
					S9xMessage2 ((GUI.Language && DirectX.Windowed) ? ".zst Z[u" : ".zst saved", 2000);
				else
					S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "G[!" : "Error!", 2000);
			}
			break;

		case ID_FILE_SCREENSHOT:
			if(GUI.StopEmulation || SPCPlayingFlag || (GUI.PauseEmulation && GUI.FullScreen))
				break;
			S9xwPauseEmulation(TRUE);
			S9xwPauseLock = TRUE;
			//Select image file format.
			if(Options.SaveImagefileFormat == 0)
				ErrResult = S9xSaveScreenImage(S9xwGetScreenImageFilename(".BMP"));
			else if(Options.SaveImagefileFormat == 1)
				ErrResult = S9xSaveScreenImage(S9xwGetScreenImageFilename(".PCX"));
			else if(Options.SaveImagefileFormat == 2)
				ErrResult = S9xSaveScreenImage(S9xwGetScreenImageFilename(".GIF"));
			else if(Options.SaveImagefileFormat == 3)
				ErrResult = S9xSaveScreenImage(S9xwGetScreenImageFilename(".PNG"));
			else
				ErrResult = S9xSaveScreenImage(S9xwGetScreenImageFilename(".BMP"));
			if(ErrResult) {
				lstrcpy(OnScreenMessageStr, S9xwGetSavedScreenImageNumberAndTypeStr());
				lstrcat(OnScreenMessageStr, (GUI.Language && DirectX.Windowed) ? " Z[u" : " saved");
			}
			else
				lstrcpy(OnScreenMessageStr, (GUI.Language && DirectX.Windowed) ? "G[!" : "Error!");
			S9xwPauseLock = FALSE;
			S9xwPauseEmulation(FALSE);
			S9xMessage2 (OnScreenMessageStr, 2000);
			break;

		case ID_FILE_EXIT:
			PostMessage( hWnd, WM_CLOSE, 0, 0);
			break;

		case ID_OPTION_DOUBLE:
			{
				if(GUI.PauseEmulation)
					break;
				DoubleRendering = !DoubleRendering;
				if(!DoubleRendering) {
					if(Settings.SixteenBit)
						DoubleRenderingModes16 = GUI.Scale;
					else
						DoubleRenderingModes8 = GUI.Scale;
					GUI.Scale = 0;
					Settings.SupportHiRes = FALSE;
				}
				else {
					//2xSaI[hւ̐؂芷̏ꍇ̃XN[obt@NA΍
					ResetRenderMethod();
					GUI.Scale = (Settings.SixteenBit ? DoubleRenderingModes16 : DoubleRenderingModes8);
					Settings.SupportHiRes = SupportHiResFlag;
				}
				CurFullscreenDisplayModeIndexChange();
				S9xwPauseEmulation(TRUE);
				if(DirectX.Windowed) {
					S9xwPauseLock = TRUE;
					GetClientRect(GUI.hWnd, &rc);
					hdc = GetDC(GUI.hWnd);
					FillRect(hdc, &rc, (HBRUSH)GetStockObject(BLACK_BRUSH));
					ReleaseDC(GUI.hWnd, hdc);

					S9xGraphicsDeinit();
					//؂芷s̃G[
					if(!S9xGraphicsInit())
					{
						S9xGraphicsDeinit();
						SetWindowText(GUI.hWnd, WindowTitleText);
						MessageBox(GUI.hWnd, Languages[GUI.Language].errSwitchGFX, "Snes9X - Switch GFX mode", MB_OK | MB_ICONSTOP);
						S9xwSetMenuStatus(GUI.hMenu, GUI.hSysMenu);
						PostMessage( GUI.hWnd, WM_CLOSE, 0, 0);
						break;
					}
					S9xInitUpdate ();
					if(GUI.StopEmulation || SPCPlayingFlag)
						S9xDrawScreenImage();
					S9xwPauseLock = FALSE;
				}
				else {
					if(!S9xwSwitchScreenMode(FALSE))
						break;
				}
				S9xwPauseEmulation(FALSE);
			}
			break;

		case ID_OPTION_ADJUSTWINDOW:
			{
				if(!DirectX.Windowed || GUI.PauseEmulation)
					break;
				RECT rcWindow;
				DoubleRendering = !DoubleRendering;
				if(!DoubleRendering) {
					if(Settings.SixteenBit)
						DoubleRenderingModes16 = GUI.Scale;
					else
						DoubleRenderingModes8 = GUI.Scale;
					GUI.Scale = 0;
					Settings.SupportHiRes = FALSE;
				}
				else {
					//2xSaI[hւ̐؂芷̏ꍇ̃XN[obt@NA΍
					ResetRenderMethod();
					GUI.Scale = (Settings.SixteenBit ? DoubleRenderingModes16 : DoubleRenderingModes8);
					Settings.SupportHiRes = SupportHiResFlag;
				}
				CurFullscreenDisplayModeIndexChange();
				S9xwPauseEmulation(TRUE);
				S9xwPauseLock = TRUE;
				GetWindowRect(hWnd, &rcWindow);
				rcWindow.right = (DoubleRendering ? DefaultWindowSizeWW[0] : DefaultWindowSizeW);
				rcWindow.bottom = (DoubleRendering ? DefaultWindowSizeHH[0] : DefaultWindowSizeH);
				MoveWindow(hWnd, rcWindow.left, rcWindow.top, rcWindow.right, rcWindow.bottom, TRUE);
				GetClientRect(GUI.hWnd, &rc);
				hdc = GetDC(GUI.hWnd);
				FillRect(hdc, &rc, (HBRUSH)GetStockObject(BLACK_BRUSH));
				ReleaseDC(GUI.hWnd, hdc);
				//݂̃EChETCYۑ
				GetWindowRect(hWnd, &WindowRectSetting);

				S9xGraphicsDeinit();
				//؂芷s̃G[
				if(!S9xGraphicsInit())
				{
					S9xGraphicsDeinit();
					SetWindowText(GUI.hWnd, WindowTitleText);
					MessageBox(GUI.hWnd, Languages[GUI.Language].errSwitchGFX, "Snes9X - Switch GFX mode", MB_OK | MB_ICONSTOP);
					S9xwSetMenuStatus(GUI.hMenu, GUI.hSysMenu);
					PostMessage( GUI.hWnd, WM_CLOSE, 0, 0);
					break;
				}
				S9xInitUpdate ();
				if(GUI.StopEmulation || SPCPlayingFlag)
					S9xDrawScreenImage();
				S9xwPauseLock = FALSE;
				S9xwPauseEmulation(FALSE);
			}
			break;

		case ID_OPTION_ADJUSTWINDOW_0:
		case ID_OPTION_ADJUSTWINDOW_1:
		case ID_OPTION_ADJUSTWINDOW_2:
		case ID_OPTION_ADJUSTWINDOW_3:
		case ID_OPTION_ADJUSTWINDOW_4:
		case ID_OPTION_ADJUSTWINDOW_5:
		case ID_OPTION_ADJUSTWINDOW_6:
		case ID_OPTION_ADJUSTWINDOW_7:
			{
				if(!DirectX.Windowed || GUI.PauseEmulation)
					break;
				RECT rcWindow;

					switch(LOWORD(wParam))
					{
						case ID_OPTION_ADJUSTWINDOW_0:
						{
							if(DoubleRendering) {
								if(Settings.SixteenBit)
								DoubleRenderingModes16 = GUI.Scale;
								else
								DoubleRenderingModes8 = GUI.Scale;
								GUI.Scale = 0;
								Settings.SupportHiRes = FALSE;
							}
							GUI.Stretch = FALSE;
							DoubleRendering = FALSE;
						}
						break;

						case ID_OPTION_ADJUSTWINDOW_1:
							GUI.Stretch = FALSE;
							DoubleRendering = TRUE;
						break;

						case ID_OPTION_ADJUSTWINDOW_2:
						case ID_OPTION_ADJUSTWINDOW_3:
						case ID_OPTION_ADJUSTWINDOW_4:
						case ID_OPTION_ADJUSTWINDOW_5:
						case ID_OPTION_ADJUSTWINDOW_6:
						case ID_OPTION_ADJUSTWINDOW_7:
							GUI.Stretch = TRUE;
							DoubleRendering = TRUE;
						break;

						default:
						break;
					}

				if(DoubleRendering){
					//2xSaI[hւ̐؂芷̏ꍇ̃XN[obt@NA΍
					ResetRenderMethod();
					GUI.Scale = (Settings.SixteenBit ? DoubleRenderingModes16 : DoubleRenderingModes8);
					Settings.SupportHiRes = SupportHiResFlag;
				}
				CurFullscreenDisplayModeIndexChange();
				S9xwPauseEmulation(TRUE);
				S9xwPauseLock = TRUE;

				GetWindowRect(hWnd, &rcWindow);

					switch(LOWORD(wParam))
					{
						case ID_OPTION_ADJUSTWINDOW_0:
							rcWindow.right = DefaultWindowSizeW;
							rcWindow.bottom = DefaultWindowSizeH;
						break;

						case ID_OPTION_ADJUSTWINDOW_1:
							rcWindow.right = DefaultWindowSizeWW[0];
							rcWindow.bottom = DefaultWindowSizeHH[0];
						break;

						case ID_OPTION_ADJUSTWINDOW_2:
							rcWindow.right = DefaultWindowSizeWW[1];
							rcWindow.bottom = DefaultWindowSizeHH[1];
						break;

						case ID_OPTION_ADJUSTWINDOW_3:
							rcWindow.right = DefaultWindowSizeWW[2];
							rcWindow.bottom = DefaultWindowSizeHH[2];
						break;

						case ID_OPTION_ADJUSTWINDOW_4:
							rcWindow.right = DefaultWindowSizeWW[3];
							rcWindow.bottom = DefaultWindowSizeHH[3];
						break;

						case ID_OPTION_ADJUSTWINDOW_5:
							rcWindow.right = DefaultWindowSizeWW[4];
							rcWindow.bottom = DefaultWindowSizeHH[4];
						break;

						case ID_OPTION_ADJUSTWINDOW_6:
							rcWindow.right = DefaultWindowSizeWW[5];
							rcWindow.bottom = DefaultWindowSizeHH[5];
						break;

						case ID_OPTION_ADJUSTWINDOW_7:
							rcWindow.right = DefaultWindowSizeWW[6];
							rcWindow.bottom = DefaultWindowSizeHH[6];
						break;

						default:
						break;
					}

				MoveWindow(hWnd, rcWindow.left, rcWindow.top, rcWindow.right, rcWindow.bottom, TRUE);
				GetClientRect(GUI.hWnd, &rc);
				hdc = GetDC(GUI.hWnd);
				FillRect(hdc, &rc, (HBRUSH)GetStockObject(BLACK_BRUSH));
				ReleaseDC(GUI.hWnd, hdc);
				//݂̃EChETCYۑ
				GetWindowRect(hWnd, &WindowRectSetting);

				S9xGraphicsDeinit();
				//؂芷s̃G[
				if(!S9xGraphicsInit())
				{
					S9xGraphicsDeinit();
					SetWindowText(GUI.hWnd, WindowTitleText);
					MessageBox(GUI.hWnd, Languages[GUI.Language].errSwitchGFX, "Snes9X - Switch GFX mode", MB_OK | MB_ICONSTOP);
					S9xwSetMenuStatus(GUI.hMenu, GUI.hSysMenu);
					PostMessage( GUI.hWnd, WM_CLOSE, 0, 0);
					break;
				}
				S9xInitUpdate ();
				if(GUI.StopEmulation || SPCPlayingFlag)
					S9xDrawScreenImage();

				if(DirectX.Windowed) {
					GetClientRect(GUI.hWnd, &rc);
					hdc = GetDC(GUI.hWnd);
					FillRect(hdc, &rc, (HBRUSH)GetStockObject(BLACK_BRUSH));
					ReleaseDC(GUI.hWnd, hdc);
					if(GUI.StopEmulation || SPCPlayingFlag)
					S9xDrawScreenImage();
				}
				else
				UpdateBackBuffer();

				S9xwPauseLock = FALSE;
				S9xwPauseEmulation(FALSE);
			}
			break;

		case ID_OPTION_STRETCH:
			S9xwPauseEmulation(TRUE);
			GUI.Stretch = !GUI.Stretch;
			if(DirectX.Windowed) {
				GetClientRect(GUI.hWnd, &rc);
				hdc = GetDC(GUI.hWnd);
				FillRect(hdc, &rc, (HBRUSH)GetStockObject(BLACK_BRUSH));
				ReleaseDC(GUI.hWnd, hdc);
				if(GUI.StopEmulation || SPCPlayingFlag)
					S9xDrawScreenImage();
			}
			else
				UpdateBackBuffer();
			S9xwPauseEmulation(FALSE);
			break;

		case ID_OPTION_CONFIG:
			if(GUI.PauseEmulation || !UIEnter())
				break;
			ConfigDlgProp(hWnd);
			Draw1FrameFlag = TRUE;
			if(errConfigSwitch)
				break;
			UIExit();
			if(IPPU.Controller != SNES_SUPERSCOPE && IPPU.Controller != SNES_JUSTIFIER && !GUI.StopEmulation && !GUI.PauseEmulation && !SPCPlayingFlag)
				S9xMessage2 ("EraseMouseCursor", 1000);
			break;

		case ID_OPTION_CHEATCODE:
			if(GUI.StopEmulation || SPCPlayingFlag || !UIEnter())
				break;
			S9xwPauseLock = TRUE;
			DisplaySNESCheatCodeWindow();
			S9xwPauseLock = FALSE;
			UIExit();
			if(IPPU.Controller != SNES_SUPERSCOPE && IPPU.Controller != SNES_JUSTIFIER && !GUI.StopEmulation && !GUI.PauseEmulation && !SPCPlayingFlag)
				S9xMessage2 ("EraseMouseCursor", 1000);
			S9xwSetMenuStatus(GUI.hMenu, GUI.hSysMenu);
			break;

		case ID_OPTION_FULLSCREEN:
			if((DirectX.Windowed && DirectX.Depth == 8) || SPCPlayingFlag)
				break;
			S9xwPauseEmulation(TRUE);
			//tXN[[hŃEChEԂŃj[쒆c
			if(GUI.FullScreen && DirectX.Windowed || (!GUI.FullScreen && DirectX.Windowed && GUI.StopEmulation))
				GUI.FullScreen = !GUI.FullScreen;
			//tXN[
			else if(!GUI.FullScreen && DirectX.Windowed && !GUI.StopEmulation) {
				if(!S9xwSwitchScreenMode(FALSE))
					break;
			}
			//EChE
			else if(GUI.FullScreen && !DirectX.Windowed && !GUI.StopEmulation) {
				if(!S9xwSwitchScreenMode(TRUE))
					break;
			}
			S9xwPauseEmulation(FALSE);
			break;

		case ID_OPTION_FPS:
			if(Settings.DisplayFrameRate)
				Settings.DisplayFrameRate = 0;
			else
				Settings.DisplayFrameRate = 1;
			break;

		//{[ύX
		case ID_OPTION_VLUP:
			if(Options.VolumeLevel < 5)
				++Options.VolumeLevel;
			lstrcpy(OnScreenMessageStr, "Level ");
			wsprintf(OnScreenMessageStr + lstrlen(OnScreenMessageStr), "%d ", Options.VolumeLevel);
			lstrcat(OnScreenMessageStr, (GUI.Language && DirectX.Windowed) ? "{[Up" : "Volume Up");
			S9xMessage2 (OnScreenMessageStr, 2000);
			break;

		case ID_OPTION_VLDOWN:
			if(Options.VolumeLevel > 1)
				--Options.VolumeLevel;
			lstrcpy(OnScreenMessageStr, "Level ");
			wsprintf(OnScreenMessageStr + lstrlen(OnScreenMessageStr), "%d ", Options.VolumeLevel);
			lstrcat(OnScreenMessageStr, (GUI.Language && DirectX.Windowed) ? "{[Down" : "Volume Down");
			S9xMessage2 (OnScreenMessageStr, 2000);
			break;

		case ID_OPTION_VL1:
			Options.VolumeLevel = 1;
			break;

		case ID_OPTION_VL2:
			Options.VolumeLevel = 2;
			break;

		case ID_OPTION_VL3:
			Options.VolumeLevel = 3;
			break;

		case ID_OPTION_VL4:
			Options.VolumeLevel = 4;
			break;

		case ID_OPTION_VL5:
			Options.VolumeLevel = 5;
			break;

		case ID_OPTION_JP:
			if(!Options.JPenvFlag)
				break;
			S9xwPauseEmulation(TRUE);
			S9xwPauseLock = TRUE;
			GUI.Language = !GUI.Language;
			if(DirectX.Windowed && GetMenu( GUI.hWnd) != NULL) {
				SetMenu( GUI.hWnd, NULL);
				GUI.AppMenuConnect = FALSE;
				if(GUI.hRecentGamesMenu)
					DestroyMenu(GUI.hRecentGamesMenu);
				GUI.hRecentGamesMenu = 0;
				DestroyMenu(GUI.hMenu);
				GUI.hMenu = LoadMenu((HINSTANCE)GetWindowLong(hWnd, GWL_HINSTANCE), MAKEINTRESOURCE( Languages[ GUI.Language].idMenu));
				InsertMenu(GetSubMenu(GUI.hMenu, 1), 5, MF_BYPOSITION, ID_OPTION_JP, GUI.Language ? "{ UI(&U)\tCtrl+U" : "English &UI\tCtrl+U");
				SetMenu( GUI.hWnd, GUI.hMenu);
				GUI.AppMenuConnect = TRUE;
				DrawMenuBar( GUI.hWnd);
			}
			else {
				if(GUI.hRecentGamesMenu)
					DestroyMenu(GUI.hRecentGamesMenu);
				GUI.hRecentGamesMenu = 0;
				DestroyMenu(GUI.hMenu);
				GUI.AppMenuConnect = FALSE;
				GUI.hMenu = LoadMenu((HINSTANCE)GetWindowLong(hWnd, GWL_HINSTANCE), MAKEINTRESOURCE( Languages[ GUI.Language].idMenu));
				InsertMenu(GetSubMenu(GUI.hMenu, 1), 5, MF_BYPOSITION, ID_OPTION_JP, GUI.Language ? "{ UI(&U)\tCtrl+U" : "English &UI\tCtrl+U");
			}
			//VXej[̃{[xj[ǉ
				DeleteMenu(GUI.hSysMenu, 0, MF_BYPOSITION);
				DeleteMenu(GUI.hSysMenu, 0, MF_BYPOSITION);
				GUI.hVolMenu = LoadMenu((HINSTANCE)GetWindowLong(hWnd, GWL_HINSTANCE), MAKEINTRESOURCE(IDR_VOLMENU));
				InsertMenu(GUI.hSysMenu, 0, MF_BYPOSITION | MF_POPUP, (UINT)GetSubMenu(GUI.hVolMenu, 0), (GUI.Language ? "{[x(&V)" : "&Volume Level"));
				InsertMenu(GUI.hSysMenu, 1, MF_BYPOSITION | MFT_SEPARATOR, 0, 0);
			S9xwPauseLock = FALSE;
			S9xwPauseEmulation(FALSE);
			break;

		case ID_OPTION_MUTE:
			Settings.Mute = !Settings.Mute;
			if(Settings.Mute)
				S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "TEhobt@vC It" : "Mute Sound", 2000);
			else
				S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "TEhobt@vC I" : "Dis Mute Sound", 2000);
			break;
		//
		//Snes9x ݒύXL[
		//
		case ID_OPTION_SETTINGS_KEY_0:
			Settings.DisableHDMA = !Settings.DisableHDMA;
			if(Settings.DisableHDMA)
				S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "HDMA G~[V It" : "HDMA emulation off", 2000);
			else
				S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "HDMA G~[V I" : "HDMA emulation on", 2000);
			break;

		case ID_OPTION_SETTINGS_KEY_1:
			if(GUI.StopEmulation || SPCPlayingFlag || GUI.PauseEmulation)
				break;
			PPU.BG_Forced ^= 1;
			if(PPU.BG_Forced & 1)
				S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "BG#0 It" : "BG#0 off", 2000);
			else
				S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "BG#0 I" : "BG#0 on", 2000);
			break;

		case ID_OPTION_SETTINGS_KEY_2:
			if(GUI.StopEmulation || SPCPlayingFlag || GUI.PauseEmulation)
				break;
			PPU.BG_Forced ^= 2;
			if(PPU.BG_Forced & 2)
				S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "BG#1 It" : "BG#1 off", 2000);
			else
				S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "BG#1 I" : "BG#1 on", 2000);
			break;

		case ID_OPTION_SETTINGS_KEY_3:
			if(GUI.StopEmulation || SPCPlayingFlag || GUI.PauseEmulation)
				break;
			PPU.BG_Forced ^= 4;
			if(PPU.BG_Forced & 4)
				S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "BG#2 It" : "BG#2 off", 2000);
			else
				S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "BG#2 I" : "BG#2 on", 2000);
			break;

		case ID_OPTION_SETTINGS_KEY_4:
			if(GUI.StopEmulation || SPCPlayingFlag || GUI.PauseEmulation)
				break;
			PPU.BG_Forced ^= 8;
			if(PPU.BG_Forced & 8)
				S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "BG#3 It" : "BG#3 off", 2000);
			else
				S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "BG#3 I" : "BG#3 on", 2000);
			break;

		case ID_OPTION_SETTINGS_KEY_5:
			if(GUI.StopEmulation || SPCPlayingFlag || GUI.PauseEmulation)
				break;
			PPU.BG_Forced ^= 16;
			if(PPU.BG_Forced & 16)
				S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "XvCg It" : "Sprites off", 2000);
			else
				S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "XvCg I" : "Sprites on", 2000);
			break;

		case ID_OPTION_SETTINGS_KEY_6:
			Settings.SwapJoypads = !Settings.SwapJoypads;
			if(Settings.SwapJoypads)
				S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "Joypad swapping I" : "Joypad swapping on", 2000);
			else
				S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "Joypad swapping It" : "Joypad swapping off", 2000);
			break;

		case ID_OPTION_SETTINGS_KEY_7:
			if(GUI.StopEmulation || SPCPlayingFlag || GUI.PauseEmulation)
				break;
			S9xNextController ();
			if(IPPU.Controller == SNES_MULTIPLAYER5) {
				S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "Multiplayer 5 I #0" : "Multiplayer 5 on #0", 2000);
				if(!GUI.ForcedPauseEmulation)
					S9xMessage2 ("EraseMouseCursor", 1000);
			}
			else if(IPPU.Controller == SNES_JOYPAD) {
				S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "Joypad I #0" : "Joypad on #0", 2000);
				if(!GUI.ForcedPauseEmulation)
					S9xMessage2 ("EraseMouseCursor", 1000);
			}
			else if(IPPU.Controller == SNES_MOUSE_SWAPPED) {
				S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "Mouse I #1" : "Mouse on #1", 2000);
				if(!GUI.ForcedPauseEmulation)
					S9xMessage2 ("EraseMouseCursor", 1000);
			}
			else if(IPPU.Controller == SNES_MOUSE) {
				S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "Mouse I #0" : "Mouse on #0", 2000);
				if(!GUI.ForcedPauseEmulation)
					S9xMessage2 ("EraseMouseCursor", 1000);
			}
			else if(IPPU.Controller == SNES_SUPERSCOPE) {
				S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "Superscope I #1" : "Superscope on #1", 2000);
				SetCursor(LoadCursor(NULL, IDC_ARROW));
			}
			else if(IPPU.Controller == SNES_JUSTIFIER) {
				S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "Justifier I #0" : "Justifier on #0", 2000);
				SetCursor(LoadCursor(NULL, IDC_ARROW));
			}
			break;

		case ID_OPTION_SETTINGS_KEY_8:
			Settings.BGLayering = !Settings.BGLayering;
			if(Settings.BGLayering)
				S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "Backgroung layering hack I" : "Backgroung layering hack on", 2000);
			else
				S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "Backgroung layering hack It" : "Backgroung layering hack off", 2000);
			break;

		case ID_OPTION_SETTINGS_KEY_9:
			if( Settings.SixteenBit)
			{
				Settings.Transparency = !Settings.Transparency;
				TransparencyFlag = Settings.Transparency;
				if(Settings.Transparency)
					S9xMessage2 ((GUI.Language && DirectX.Windowed) ? " I" : "Transparency effects on", 2000);
				else
					S9xMessage2 ((GUI.Language && DirectX.Windowed) ? " It" : "Transparency effects off", 2000);
			}
			break;

		case ID_OPTION_SETTINGS_KEY_BACK:
			Settings.DisableGraphicWindows = !Settings.DisableGraphicWindows;
			if(Settings.DisableGraphicWindows)
				S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "Graphic clip windows It" : "Graphic clip windows off", 2000);
			else
				S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "Graphic clip windows I" : "Graphic clip windows on", 2000);
			break;

		case ID_OPTION_SETTINGS_KEY_TURBO:
			//^[{[h
			Settings.TurboMode = !Settings.TurboMode;
			if(Settings.TurboMode) {
				lstrcpy(WindowTitleTextNormal, WindowTitleTextTurbo);
				if(!GUI.PauseEmulation)
					lstrcpy(WindowTitleText, WindowTitleTextTurbo);
				lstrcpy(OnScreenMessageStr, (GUI.Language && DirectX.Windowed) ? "^[{[h I (XLbv " : "Turbo Mode on (Skip ");
				wsprintf(&OnScreenMessageStr[lstrlen(OnScreenMessageStr)], "%d)", Settings.TurboSkipFrames);
				S9xMessage2 (OnScreenMessageStr, 2000);
			}
			else {
				lstrcpy(WindowTitleTextNormal, WindowTitleTextNormal_bak);
				if(!GUI.PauseEmulation)
					lstrcpy(WindowTitleText, WindowTitleTextNormal_bak);
				S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "^[{[h It" : "Turbo Mode off", 2000);
			}
			break;

		case ID_OPTION_SETTINGS_KEY_TURBOFRAMESKIPINC:
			if(Settings.TurboSkipFrames < 15)
				Settings.TurboSkipFrames++;
			else
				Settings.TurboSkipFrames = 15;
			lstrcpy(OnScreenMessageStr, (GUI.Language && DirectX.Windowed) ? "^[{XLbvt[ " : "TurboSkipFrames ");
			wsprintf(&OnScreenMessageStr[lstrlen(OnScreenMessageStr)], "%d", Settings.TurboSkipFrames);
			S9xMessage2 (OnScreenMessageStr, 2000);
			break;

		case ID_OPTION_SETTINGS_KEY_TURBOFRAMESKIPDEC:
			if(Settings.TurboSkipFrames > 0)
				Settings.TurboSkipFrames--;
			else
				Settings.TurboSkipFrames = 0;
			lstrcpy(OnScreenMessageStr, (GUI.Language && DirectX.Windowed) ? "^[{XLbvt[ " : "TurboSkipFrames ");
			wsprintf(&OnScreenMessageStr[lstrlen(OnScreenMessageStr)], "%d", Settings.TurboSkipFrames);
			S9xMessage2 (OnScreenMessageStr, 2000);
			break;

		case ID_OPTION_SETTINGS_KEY_PAUSE:
			if(!GUI.PauseEmulation) {
				S9xwPauseEmulation(TRUE);
				GUI.PauseEmulation = GUI.PauseEmulation ^ true;
				lstrcpy(WindowTitleText, WindowTitleTextPaused);
				S9xwSetMenuStatus(GUI.hMenu, GUI.hSysMenu);
				hMenu = GetMenu(hWnd);
				S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "Pause I" : "Pause on", 2000);
				SetCursor(LoadCursor(NULL, IDC_ARROW));
			}
			else {
				GUI.PauseEmulation = GUI.PauseEmulation ^ true;
				S9xwPauseEmulation(FALSE);
				lstrcpy(WindowTitleText, WindowTitleTextNormal);
				S9xwSetMenuStatus(GUI.hMenu, GUI.hSysMenu);
				S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "Pause It" : "Pause off", 2000);
				if(IPPU.Controller != SNES_SUPERSCOPE && IPPU.Controller != SNES_JUSTIFIER && !GUI.StopEmulation && !GUI.ForcedPauseEmulation && !GUI.PauseEmulation && !SPCPlayingFlag)
					S9xMessage2 ("EraseMouseCursor", 1000);
			}
			break;

		case ID_OPTION_SETTINGS_KEY_APPLYCHEATS:
			Settings.ApplyCheats = !Settings.ApplyCheats;
			if(Settings.ApplyCheats)
				S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "`[gR[hL" : "Cheat code on", 2000);
			else
				S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "`[gR[h" : "Cheat code off", 2000);
			break;

		case ID_OPTION_SNESJOYPAD:
			if(GUI.StopEmulation || SPCPlayingFlag || GUI.PauseEmulation)
				break;
			IPPU.Controller = SNES_JOYPAD;
			S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "Joypad I #0" : "Joypad on #0", 2000);
			if(!GUI.ForcedPauseEmulation)
				S9xMessage2 ("EraseMouseCursor", 1000);
			break;

		case ID_OPTION_SNESMULTIPLAYER5:
			if(GUI.StopEmulation || SPCPlayingFlag || GUI.PauseEmulation || !Settings.MultiPlayer5)
				break;
			IPPU.Controller = SNES_MULTIPLAYER5;
			S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "Multiplayer 5 I #0" : "Multiplayer 5 on #0", 2000);
			if(!GUI.ForcedPauseEmulation)
				S9xMessage2 ("EraseMouseCursor", 1000);
			break;

		case ID_OPTION_SNESMOUSE1:
			if(GUI.StopEmulation || SPCPlayingFlag || GUI.PauseEmulation || !Settings.Mouse)
				break;
			IPPU.Controller = SNES_MOUSE_SWAPPED;
			S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "Mouse I #1" : "Mouse on #1", 2000);
			if(!GUI.ForcedPauseEmulation)
				S9xMessage2 ("EraseMouseCursor", 1000);
			break;

		case ID_OPTION_SNESMOUSE0:
			if(GUI.StopEmulation || SPCPlayingFlag || GUI.PauseEmulation || !Settings.Mouse)
				break;
			IPPU.Controller = SNES_MOUSE;
			S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "Mouse I #0" : "Mouse on #0", 2000);
			if(!GUI.ForcedPauseEmulation)
				S9xMessage2 ("EraseMouseCursor", 1000);
			break;

		case ID_OPTION_SNESSUPERSCOPE:
			if(GUI.StopEmulation || SPCPlayingFlag || GUI.PauseEmulation || !Settings.SuperScope)
				break;
			IPPU.Controller = SNES_SUPERSCOPE;
			S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "Superscope I #1" : "Superscope on #1", 2000);
			SetCursor(LoadCursor(NULL, IDC_ARROW));
			break;

		case ID_OPTION_SNESJUSTIFIER:
			if(GUI.StopEmulation || SPCPlayingFlag || GUI.PauseEmulation || !Settings.Justifier)
				break;
			IPPU.Controller = SNES_JUSTIFIER;
			S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "Justifier I #0" : "Justifier on #0", 2000);
			SetCursor(LoadCursor(NULL, IDC_ARROW));
			break;

		//ԃZ[u
		case ID_FILE_SAVESLOT_1:
		case ID_FILE_SAVESLOT_2:
		case ID_FILE_SAVESLOT_3:
		case ID_FILE_SAVESLOT_4:
		case ID_FILE_SAVESLOT_5:
		case ID_FILE_SAVESLOT_6:
		case ID_FILE_SAVESLOT_7:
		case ID_FILE_SAVESLOT_8:
		case ID_FILE_SAVESLOT_9:
			S9xwStateSave(LOWORD(wParam) - ID_FILE_SAVESLOT_1 + 1);
			break;

		//ԃ[h
		case ID_FILE_LOADSLOT_1:
		case ID_FILE_LOADSLOT_2:
		case ID_FILE_LOADSLOT_3:
		case ID_FILE_LOADSLOT_4:
		case ID_FILE_LOADSLOT_5:
		case ID_FILE_LOADSLOT_6:
		case ID_FILE_LOADSLOT_7:
		case ID_FILE_LOADSLOT_8:
		case ID_FILE_LOADSLOT_9:
			S9xwStateLoad(LOWORD(wParam) - ID_FILE_LOADSLOT_1 + 1);
			break;

		case ID_MAPFUNC:
			//Slot 1-9 save
			if(LOWORD(lParam) < MF_LOAD1) {
				S9xwStateSave(LOWORD(lParam) - MF_SAVE1 + 1);
			}
			//Slot 1-9 load
			else if(LOWORD(lParam) > MF_SAVE5 && LOWORD(lParam) < MF_TURBO) {
				wsprintf(tmpcharbuf, ".%03d", LOWORD(lParam) - MF_LOAD1);
				if(GetFileAttributes(S9xGetFilename(tmpcharbuf)) != 0xffffffff)
					S9xwStateLoad(LOWORD(lParam) - MF_LOAD1 + 1);
			}
			//Toggle Turbo Mode
			else if(LOWORD(lParam) == MF_TURBO) {
				Settings.TurboMode = !Settings.TurboMode;
				if(Settings.TurboMode) {
					lstrcpy(WindowTitleTextNormal, WindowTitleTextTurbo);
					lstrcpy(WindowTitleText, WindowTitleTextTurbo);
					lstrcpy(OnScreenMessageStr, (GUI.Language && DirectX.Windowed) ? "^[{[h I (XLbv " : "Turbo Mode on (Skip ");
					wsprintf(&OnScreenMessageStr[lstrlen(OnScreenMessageStr)], "%d)", Settings.TurboSkipFrames);
					S9xMessage2 (OnScreenMessageStr, 2000);
				}
				else {
					lstrcpy(WindowTitleTextNormal, WindowTitleTextNormal_bak);
					lstrcpy(WindowTitleText, WindowTitleTextNormal_bak);
					S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "^[{[h It" : "Turbo Mode off", 2000);
				}
			}
			//Press Turbo Mode
			else if(LOWORD(lParam) == MF_TURBOPAUSEFWD) {
				Settings.TurboMode = !Settings.TurboMode;
				if(Settings.TurboMode) {
				//	lstrcpy(WindowTitleTextNormal, WindowTitleTextTurbo);
				//	lstrcpy(WindowTitleText, WindowTitleTextTurbo);
				//	lstrcpy(OnScreenMessageStr, (GUI.Language && DirectX.Windowed) ? "^[{[h I (XLbv " : "Turbo Mode on (Skip ");
				//	wsprintf(&OnScreenMessageStr[lstrlen(OnScreenMessageStr)], "%d)", Settings.TurboSkipFrames);
				//	S9xMessage2 (OnScreenMessageStr, 2000);
				}
				else {
				//	lstrcpy(WindowTitleTextNormal, WindowTitleTextNormal_bak);
				//	lstrcpy(WindowTitleText, WindowTitleTextNormal_bak);
				//	S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "^[{[h It" : "Turbo Mode off", 2000);
				}
			}
			//Reset
			else if(LOWORD(lParam) == MF_RESET) {
				S9xwPauseEmulation(TRUE);
				S9xReset();
#ifdef UNCO_FULL_TEAM
                     BSX_TIMESET (); // Original
#endif
				ScreenBufferClear();
				if(GUI.FullScreen && DirectX.Windowed)
				{
					if(!S9xwSwitchScreenMode(FALSE))
						break;
				}
				else
					UpdateBackBuffer();
				S9xwPauseEmulation(FALSE);
			}
			//Soft Reset
			else if(LOWORD(lParam) == MF_SOFTRESET) {
				S9xwPauseEmulation(TRUE);
				S9xSoftReset();
#ifdef UNCO_FULL_TEAM
                     BSX_TIMESET (); // Original
#endif
				ScreenBufferClear();
				if(GUI.FullScreen && DirectX.Windowed)
				{
					if(!S9xwSwitchScreenMode(FALSE))
						break;
				}
				else
					UpdateBackBuffer();
				S9xwPauseEmulation(FALSE);
			}
			//SPC dump
			else if(LOWORD(lParam) == MF_SPCDUMP) {
				ErrResult = S9xwSPCDump(S9xwGetSPCFilename(), FALSE);
				if(ErrResult) {
					lstrcpy(OnScreenMessageStr, S9xwGetSavedSPCNumberAndExtStr());
					lstrcat(OnScreenMessageStr, (GUI.Language && DirectX.Windowed) ? " Z[u" : " saved");
				}
				else
					lstrcpy(OnScreenMessageStr, (GUI.Language && DirectX.Windowed) ? "G[!" : "Error!");
				S9xMessage2 (OnScreenMessageStr, 2000);
			}
			//Screenshot
			else if(LOWORD(lParam) == MF_SCREENSHOT) {
				S9xwPauseEmulation(TRUE);
				S9xwPauseLock = TRUE;
				//Select image file format.
				if(Options.SaveImagefileFormat == 0)
					ErrResult = S9xSaveScreenImage(S9xwGetScreenImageFilename(".BMP"));
				else if(Options.SaveImagefileFormat == 1)
					ErrResult = S9xSaveScreenImage(S9xwGetScreenImageFilename(".PCX"));
				else if(Options.SaveImagefileFormat == 2)
					ErrResult = S9xSaveScreenImage(S9xwGetScreenImageFilename(".GIF"));
				else if(Options.SaveImagefileFormat == 3)
					ErrResult = S9xSaveScreenImage(S9xwGetScreenImageFilename(".PNG"));
				else
					ErrResult = S9xSaveScreenImage(S9xwGetScreenImageFilename(".BMP"));
				if(ErrResult) {
					lstrcpy(OnScreenMessageStr, S9xwGetSavedScreenImageNumberAndTypeStr());
					lstrcat(OnScreenMessageStr, (GUI.Language && DirectX.Windowed) ? " Z[u" : " saved");
				}
				else
					lstrcpy(OnScreenMessageStr, (GUI.Language && DirectX.Windowed) ? "G[!" : "Error!");
				S9xwPauseLock = FALSE;
				S9xwPauseEmulation(FALSE);
				S9xMessage2 (OnScreenMessageStr, 2000);
			}
			// Original 
			else if(LOWORD(lParam) == MF_XPP01) {
#ifdef UNCO_FULL_TEAM
				if(Xppbsx.BsxRomCheck) BSX_WORK ();
#endif
				XPP_ROMCHEAT_CODE (ROMCHEAT_SELECT);
			}
			else if(LOWORD(lParam) == MF_XPP02) {
#ifdef UNCO_FULL_TEAM
				if(Xppbsx.BsxRomCheck) BSX_TIMESKIP ();
#endif
				XPP_ROMCHEAT_CODE (ROMCHEAT_CODE);
			}
			else if(LOWORD(lParam) == MF_XPP03) {
#ifdef UNCO_FULL_TEAM
				if(Xppbsx.BsxRomCheck) BSX_TIMEBACK ();
#endif

				Xppcode.CheatNumBackFlag=1;
				XPP_ROMCHEAT_CODE (ROMCHEAT_SELECT);
				Xppcode.CheatNumBackFlag=0;
			}
			else if(LOWORD(lParam) == MF_XPP04) {
#ifdef UNCO_FULL_TEAM
				if(Xppbsx.BsxRomCheck) BSX_WORKEXTRA ();
#endif

				if(SNESGameFixes.VoicerKun){
 			               Xppcdda.VoicerCDChange = TRUE;
 			               lstrcpy(OnScreenMessageStr, "Disc Change");
 			               S9xMessage2 (OnScreenMessageStr, 2000);}

			}
			else if(LOWORD(lParam) == MF_XPP05) {

			    if(Settings.FrameTimeNTSC == 16 && Settings.FrameTimePAL == 20)
			    {
			         Xppsystem.SpeedEnable ^= 1;

			               if(!Xppsystem.SpeedEnable)
			               {
			                  if(Settings.PAL)
			                  Settings.FrameTime = 20;
			                  else
			                  Settings.FrameTime = 16;
			               }
 			               else if(Xppsystem.Speedflag == 0)
			               {
			                  if(Settings.PAL)
			                  Settings.FrameTime = 15;
			                  else
			                  Settings.FrameTime = 12;
			               }
 			               else if(Xppsystem.Speedflag == 1)
			               {
			                  if(Settings.PAL)
			                  Settings.FrameTime = 12;
			                  else
			                  Settings.FrameTime = 10;
			               }
 			               else if(Xppsystem.Speedflag == 2)
			               {
			                  if(Settings.PAL)
			                  Settings.FrameTime = 10;
			                  else
			                  Settings.FrameTime = 8;
			               }
 			               else if(Xppsystem.Speedflag == 3)
			               {
			                  if(Settings.PAL)
			                  Settings.FrameTime = 80;
			                  else
			                  Settings.FrameTime = 64;
			               }
 			               else if(Xppsystem.Speedflag == 4)
			               {
			                  if(Settings.PAL)
			                  Settings.FrameTime = 40;
			                  else
			                  Settings.FrameTime = 32;
			               }
 			               else if(Xppsystem.Speedflag == 5)
			               {
			                  if(Settings.PAL)
			                  Settings.FrameTime = 30;
			                  else
			                  Settings.FrameTime = 24;
			               }

 			               lstrcpy(OnScreenMessageStr, "Change Game Speed ");
 			               wsprintf(OnScreenMessageStr + lstrlen(OnScreenMessageStr), "%d ", Settings.FrameTime);
 			               lstrcat(OnScreenMessageStr, (GUI.Language && DirectX.Windowed) ? "ms" : "ms");
 			               S9xMessage2 (OnScreenMessageStr, 2000);

			    }

			}
			else if(LOWORD(lParam) == MF_XPP06) {

			    if(Settings.FrameTimeNTSC == 16 && Settings.FrameTimePAL == 20)
			    {
			               if(Xppsystem.Speedflag < 5) 
			                  Xppsystem.Speedflag++;
			               else
			                  Xppsystem.Speedflag=0;

			        if(Settings.PAL)
			        {		
 			               if(Xppsystem.Speedflag == 0)
			                  S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "XPP KEY 5 [Change Game Speed 15 ms]" : "XPP KEY 5 [Change Game Speed 15 ms]", 2000);
 			               else if(Xppsystem.Speedflag == 1)
			                  S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "XPP KEY 5 [Change Game Speed 12 ms]" : "XPP KEY 5 [Change Game Speed 12 ms]", 2000);
 			               else if(Xppsystem.Speedflag == 2)
			                  S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "XPP KEY 5 [Change Game Speed 10 ms]" : "XPP KEY 5 [Change Game Speed 10 ms]", 2000);
 			               else if(Xppsystem.Speedflag == 3)
			                  S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "XPP KEY 5 [Change Game Speed 80 ms]" : "XPP KEY 5 [Change Game Speed 80 ms]", 2000);
 			               else if(Xppsystem.Speedflag == 4)
			                  S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "XPP KEY 5 [Change Game Speed 40 ms]" : "XPP KEY 5 [Change Game Speed 40 ms]", 2000);
 			               else if(Xppsystem.Speedflag == 5)
			                  S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "XPP KEY 5 [Change Game Speed 30 ms]" : "XPP KEY 5 [Change Game Speed 30 ms]", 2000);
			        }
			        else
			        {		
 			               if(Xppsystem.Speedflag == 0)
			                  S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "XPP KEY 5 [Change Game Speed 12 ms]" : "XPP KEY 5 [Change Game Speed 12 ms]", 2000);
 			               else if(Xppsystem.Speedflag == 1)
			                  S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "XPP KEY 5 [Change Game Speed 10 ms]" : "XPP KEY 5 [Change Game Speed 10 ms]", 2000);
 			               else if(Xppsystem.Speedflag == 2)
			                  S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "XPP KEY 5 [Change Game Speed 8 ms]" : "XPP KEY 5 [Change Game Speed 8 ms]", 2000);
 			               else if(Xppsystem.Speedflag == 3)
			                  S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "XPP KEY 5 [Change Game Speed 64 ms]" : "XPP KEY 5 [Change Game Speed 64 ms]", 2000);
 			               else if(Xppsystem.Speedflag == 4)
			                  S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "XPP KEY 5 [Change Game Speed 32 ms]" : "XPP KEY 5 [Change Game Speed 32 ms]", 2000);
 			               else if(Xppsystem.Speedflag == 5)
			                  S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "XPP KEY 5 [Change Game Speed 24 ms]" : "XPP KEY 5 [Change Game Speed 24 ms]", 2000);
			        }		
			    }

			}
			else if(LOWORD(lParam) == MF_XPP07) {
			   if(XppMovie.Replay_play==false && XppMovie.Replay_rec==false)
			   {
			                  XppMovie.Replay_rec = true;
			                  XppMovie.Replay_play = false;
			                  XppMovie.Replay_count = 0;
			                  S9xwStateSaveReplay();
			                  XPP_REPLAY_START();
			   }
			   else
			   {

			      if(XppMovie.Replay_rec==true)
			                  S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "Movie Rec Stop" : "Movie Rec Stop", 2000);

			      if(XppMovie.Replay_play==true)
			                  S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "Movie Play Stop" : "Movie Play Stop", 2000);

			      XPP_REPLAY_END ();
			   }
			}
			else if(LOWORD(lParam) == MF_XPP08) {
			   if(XppMovie.Replay_play==false && XppMovie.Replay_rec==false)
			   {
			                  XppMovie.Replay_play = true;
			                  XppMovie.Replay_rec = false;
			                  XppMovie.Def_NormalSnap = Settings.Normalsnap;
			                  Settings.Normalsnap = TRUE;
			                  S9xwStateLoadReplay();
			                  if(XppMovie.Replay_play) XPP_REPLAY_LOAD ();
			                  Settings.Normalsnap = XppMovie.Def_NormalSnap;
			                  XPP_REPLAY_START();
			   }
			   else
			   {
			      if(XppMovie.Replay_rec==true)
			                  S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "Movie Rec Stop" : "Movie Rec Stop", 2000);

			      if(XppMovie.Replay_play==true)
			                  S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "Movie Play Stop" : "Movie Play Stop", 2000);

			      XPP_REPLAY_END ();
			   }
			}
			else if(LOWORD(lParam) == MF_XPP09) {
			   if(XppMovie.Replay_play==true || XppMovie.Replay_rec==true)
			   {
			      if(XppMovie.Replay_rec==true)
			                  S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "Movie Rec Stop" : "Movie Rec Stop", 2000);

			      if(XppMovie.Replay_play==true)
			                  S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "Movie Play Stop" : "Movie Play Stop", 2000);

			      XPP_REPLAY_END ();
			   }
			}
			else if(LOWORD(lParam) == MF_SSTURBO) {
			                 superscope_turbo ^= 1;
			}
			else if(LOWORD(lParam) == MF_SSPAUSE) {
			                 superscope_pause = TRUE;
			}
		}
		break;

	case WM_ENTERMENULOOP:
		if(!UIEnter())
			break;
		S9xwSetMenuStatus(GUI.hMenu, GUI.hSysMenu);
		SwitchToGDI();
		DrawMenuBar( GUI.hWnd);
		break;

	case WM_NCLBUTTONDOWN:
		S9xwKillMessageTimer();
		if(!GUI.FullScreen && DirectX.Windowed && wParam == HTCAPTION)
		{
			ncbuttondown_flag = 1;
			S9xwPauseEmulation(TRUE);
		}
		break;

	case WM_PAINT:
		if(NeedJoystickInit) {
			NeedJoystickInit = 0;
			S9xwJoystickInit();
		}
		if(NeedScreenImage) {
			NeedScreenImage = 0;
			S9xDrawScreenImage();
		}
		if(CmdLineROMLoadFlag) {
			CmdLineROMLoadFlag = 0;
			S9xwPauseEmulation(TRUE);
			ROMLoadProc(ROMFileName);
			if(!GUI.StopEmulation)
				SetPriorityClassAndThreadPriority(GUI.PriorityClass, GUI.ThreadPriority);
			else
				SetPriorityClassAndThreadPriority(NORMAL_PRIORITY_CLASS, THREAD_PRIORITY_NORMAL);
			S9xwPauseEmulation(FALSE);
			if(IPPU.Controller != SNES_SUPERSCOPE && IPPU.Controller != SNES_JUSTIFIER && !GUI.StopEmulation && !GUI.PauseEmulation && !SPCPlayingFlag)
				S9xMessage2 ("EraseMouseCursor", 1000);
		}
		
//		if(GUI.FullScreen || SPCPlayingFlag || GUI.StopEmulation)
		if(!DirectX.Windowed)
			break;
		ScreenRedraw(hWnd);
		break;

	case WM_CAPTURECHANGED:
		if(!GUI.FullScreen && DirectX.Windowed && ncbuttondown_flag)
		{
			ncbuttondown_flag = 0;
			S9xwPauseEmulation(FALSE);
		}
		break;

	// user is moving window
	case WM_ENTERSIZEMOVE:
		if(!GUI.FullScreen && DirectX.Windowed)
			S9xwPauseEmulation(TRUE);
		break;

	case WM_EXITSIZEMOVE:
		SizingFlag = FALSE;
		if(!GUI.FullScreen && DirectX.Windowed) {
			//݂̃EChETCYۑ
			GetWindowRect(hWnd, &WindowRectSetting);
			S9xwPauseEmulation(FALSE);
		}
		break;

	case WM_SIZE:
		switch(wParam)
		{
			case SIZE_MINIMIZED:
				MinimizedFlag = 1;
				break;

			case SIZE_RESTORED:
				if(MinimizedFlag == 2 && DirectX.Windowed && !GUI.FullScreen && !GUI.StopEmulation) {
					MinimizedFlag = 0;
					S9xwPauseEmulation(TRUE);
					if(!S9xwSwitchScreenMode(FALSE))
						break;
					S9xwPauseEmulation(FALSE);
				}
				//EChETCYύXɃQ[oȂ悤ɂ
				else if(!SizingFlag && !GUI.FullScreen && DirectX.Windowed && !GUI.StopEmulation)
					S9xwPauseEmulation(FALSE);
				if(SizingFlag && DirectX.Windowed)
				{
					GetClientRect(hWnd, &rc);
					RedrawDstH = ExtendHeight ? 239 : 224;
					RedrawDstW= 256;
					if(GUI.Scale > 0)
						RedrawDstH <<= 1;
					if(GUI.Scale > 0)
						RedrawDstW <<= 1;
					if(!GUI.Stretch && (RedrawDstW < (rc.right - rc.left) || RedrawDstH < (rc.bottom - rc.top)))
					{
						hRgn1 = CreateRectRgn(0, 0, 1, 1);
						hRgn2 = CreateRectRgn(rc.left, rc.top, rc.right, rc.bottom);
						if(RedrawDstW < (rc.right - rc.left))
						{
							rc.left = ((rc.right - rc.left) - RedrawDstW) / 2;
							rc.right = rc.left + RedrawDstW;
						}
						if(RedrawDstH < (rc.bottom - rc.top))
						{
							rc.top = ((rc.bottom - rc.top) - RedrawDstH) / 2;
							rc.bottom = rc.top + RedrawDstH;
						}
						hRgn3 = CreateRectRgn(rc.left, rc.top, rc.right, rc.bottom);
						CombineRgn(hRgn1, hRgn2, hRgn3, RGN_XOR);
						DeleteObject(hRgn2);
						DeleteObject(hRgn3);
						hdc = GetDC(hWnd);
						SelectClipRgn(hdc, hRgn1);
						GetClientRect(hWnd, &rc);
						FillRect(hdc, &rc, (HBRUSH)GetStockObject(BLACK_BRUSH));
						DeleteObject(hRgn1);
						ReleaseDC(hWnd, hdc);
						ScreenRedraw(hWnd);
					}
					else if((rc.right - rc.left) || (rc.bottom - rc.top))
						ScreenRedraw(hWnd);
				}
				MinimizedFlag = 0;
				break;
			
			default:
				break;
		}
		break;

	case WM_SIZING:
		if(!DirectX.Windowed || MinimizedFlag)
			break;
		else if(!SizingFlag)
		{
			S9xwPauseEmulation(TRUE);
			SizingFlag = TRUE;
		}
		break;
		
	case WM_CLOSE:
		SetPriorityClassAndThreadPriority(NORMAL_PRIORITY_CLASS, THREAD_PRIORITY_NORMAL);
		DragAcceptFiles(hWnd, FALSE); //hbOhbv
		//݂̃EChETCYۑ
		if(DirectX.Windowed && !MinimizedFlag)
			GetWindowRect(hWnd, &WindowRectSetting);
		S9xwKillMessageTimer();
		DestroyWindow(hWnd);
		return 0;

	case WM_DESTROY:
		PostQuitMessage(0);
		break;

	case WM_SYSCOMMAND:
		switch( LOWORD(wParam))
		{
		case ID_OPTION_VL1:
			Options.VolumeLevel = 1;
			return DefWindowProc( hWnd, uMsg, wParam, lParam);

		case ID_OPTION_VL2:
			Options.VolumeLevel = 2;
			return DefWindowProc( hWnd, uMsg, wParam, lParam);

		case ID_OPTION_VL3:
			Options.VolumeLevel = 3;
			return DefWindowProc( hWnd, uMsg, wParam, lParam);

		case ID_OPTION_VL4:
			Options.VolumeLevel = 4;
			return DefWindowProc( hWnd, uMsg, wParam, lParam);

		case ID_OPTION_VL5:
			Options.VolumeLevel = 5;
			return DefWindowProc( hWnd, uMsg, wParam, lParam);
		}
		switch(wParam & 0xfff0) // & to catch double-click on title bar maximize
		{
			case SC_MINIMIZE:
				if(!GUI.FullScreen && DirectX.Windowed && !SPCPlayingFlag)
					S9xwPauseEmulation(TRUE);
				MinimizedFlag = 1;
				break;

			case SC_MAXIMIZE:
				if(MinimizedFlag) {
					if(!SPCPlayingFlag)
						MinimizedFlag = 2;
					SendMessage(hWnd, WM_SYSCOMMAND, (WPARAM)SC_RESTORE, 0);
				}
				else if(DirectX.Windowed && !GUI.FullScreen && !GUI.StopEmulation && !GUI.ForcedPauseEmulation && !SPCPlayingFlag && !(DirectX.Windowed && DirectX.Depth == 8)) {
					S9xwPauseEmulation(TRUE);
					if(!S9xwSwitchScreenMode(FALSE))
						break;
					S9xwPauseEmulation(FALSE);
				}
				return 0;

			case SC_RESTORE:
				if(MinimizedFlag == 1)
					MinimizedFlag = 0;
				break;
			
			default:
				break;
		}
		break;

	default:
		break;
	}
	return DefWindowProc( hWnd, uMsg, wParam, lParam);
}

/*****************************************************************************/
/* WinInit                                                                   */
/*****************************************************************************/

static LPCTSTR uosxwlpszClassName = "uosnes: WndClass";

#if 1 // G[\
static LPTOP_LEVEL_EXCEPTION_FILTER pass_thru_filter;
static LONG CALLBACK exception_filter(struct _EXCEPTION_POINTERS *info);

static LONG CALLBACK exception_filter(struct _EXCEPTION_POINTERS *info)
{
	// exit
	return 1;
}
#endif

BOOL WinInit( HINSTANCE hInstance)
{
  WNDCLASSEX wndclass;
  POINT p;

  wndclass.cbSize = sizeof(WNDCLASSEX);
	wndclass.style = 0;
	wndclass.lpfnWndProc = WinProc;
	wndclass.cbClsExtra = 0;
	wndclass.cbWndExtra = 0;
	wndclass.hInstance = hInstance;
	//wndclass.hIcon = LoadIcon(hInstance, MAKEINTRESOURCE(IICON));
	wndclass.hIcon = LoadIcon(hInstance, MAKEINTRESOURCE(UOSXWICON32));
	wndclass.hCursor = NULL;
	wndclass.hbrBackground = (HBRUSH)GetStockObject(BLACK_BRUSH);
	wndclass.lpszMenuName = 0;
	wndclass.lpszClassName = uosxwlpszClassName;
	//wndclass.hIconSm = NULL;
	wndclass.hIconSm = LoadIcon(hInstance, MAKEINTRESOURCE(UOSXWICON16));

#if 1 // G[\
	pass_thru_filter = SetUnhandledExceptionFilter(exception_filter);
#endif

	GUI.hInstance = hInstance;

	if( !RegisterClassEx( &wndclass))
		return FALSE;
	
	if( (GUI.hMenu = LoadMenu( hInstance, MAKEINTRESOURCE( Languages[ GUI.Language].idMenu))) == NULL) {
		UnregisterClass(wndclass.lpszClassName, hInstance);
		return FALSE;
	}
	if((GUI.hVolMenu = LoadMenu( hInstance, MAKEINTRESOURCE(IDR_VOLMENU))) == NULL) {
		DestroyMenu(GUI.hMenu);
		UnregisterClass(wndclass.lpszClassName, hInstance);
		return FALSE;
	}
	if(Options.JPenvFlag)
		InsertMenu(GetSubMenu(GUI.hMenu, 1), 5, MF_BYPOSITION, ID_OPTION_JP, GUI.Language ? "{ UI(&U)\tCtrl+U" : "English &UI\tCtrl+U");

	SystemParametersInfo(SPI_GETWORKAREA, 0, &rc, 0);

	//EChETCYʒuݒǂݍ݂ĂȂꍇA܂͓ǂݍ񂾃EChETCYݒ肪sȏꍇ
	if((WindowRectSetting.left == -1 && WindowRectSetting.right == -1 && WindowRectSetting.top == -1 && WindowRectSetting.bottom == -1)
		|| (WindowRectSetting.right - WindowRectSetting.left) < DefaultWindowSizeW || (WindowRectSetting.bottom - WindowRectSetting.top) < DefaultWindowSizeH)
	{
		WindowSizeW = DefaultWindowSizeW;
		WindowSizeH = DefaultWindowSizeH;
		p = *GetWindowPosCenter(WindowSizeW, WindowSizeH);
		WindowRectSetting.left = p.x;
		WindowRectSetting.top = p.y;
		WindowRectSetting.right = (p.x + WindowSizeW);
		WindowRectSetting.bottom = (p.y + WindowSizeH);
	}
	//ǂݍ񂾃EChEʒuݒ肪Ɨ̈̈ʒuTCYƔrĖꍇ
	else if((rc.right - 50) < WindowRectSetting.left || (rc.bottom - 50) < WindowRectSetting.top || rc.top > WindowRectSetting.top || WindowRectSetting.right < 50)
	{
		WindowSizeW = (WindowRectSetting.right - WindowRectSetting.left);
		WindowSizeH = (WindowRectSetting.bottom - WindowRectSetting.top);
		p = *GetWindowPosCenter(WindowSizeW, WindowSizeH);
		WindowRectSetting.left = p.x;
		WindowRectSetting.top = p.y;
		WindowRectSetting.right = (p.x + WindowSizeW);
		WindowRectSetting.bottom = (p.y + WindowSizeH);
	}
	//ǂݍ񂾃EChETCYʒuݒŃEChE
	else {
		WindowSizeW = (WindowRectSetting.right - WindowRectSetting.left);
		WindowSizeH = (WindowRectSetting.bottom - WindowRectSetting.top);
		p.x = WindowRectSetting.left;
		p.y = WindowRectSetting.top;
	}

	if( (GUI.hWnd = CreateWindow(
		uosxwlpszClassName,
		WindowTitleText,
		GUI.dwStyleWindowed,
		p.x,
		p.y,
		WindowSizeW, WindowSizeH,
		NULL,
		NULL,
		hInstance,
		NULL)) == NULL) {
		UnregisterClass(wndclass.lpszClassName, hInstance);
		return FALSE;
	}

	//j[Zbg
	SetMenu( GUI.hWnd, GUI.hMenu);
	GUI.AppMenuConnect = TRUE;

	GUI.hSysMenu = GetSystemMenu(GUI.hWnd, FALSE);
	/* svȃVXej[폜 */
//	for (int i = 2; i < 3; i++)
//		DeleteMenu(GUI.hSysMenu, i, MF_BYPOSITION);
		InsertMenu(GUI.hSysMenu, 0, MF_BYPOSITION | MF_POPUP, (UINT)GetSubMenu(GUI.hVolMenu, 0), (GUI.Language ? "{[x(&V)" : "&Volume Level"));
		InsertMenu(GUI.hSysMenu, 1, MF_BYPOSITION | MFT_SEPARATOR, 0, 0);
	return TRUE;
}

void WinSave( void)
{
	WriteIniFile();
}

extern long _rate;
extern bool _sixteen_bit;
extern bool _stereo;
extern long _buffernos;
extern long _buffersize;
extern long _samplecount;
extern long _bytecount;
extern unsigned long _interval;

extern bool8 mmx_cpu;


/*****************
 default settings
*****************/
char GUI_SoundMode_def = 21;
int Settings_SoundBufferSize_def = 4;
int Settings_SoundMixInterval_def = 10;
int DoubleRenderingModes16_def = 2;
int DoubleRenderingModes8_def = 2;
unsigned char ForceWindowedDirectDrawClipper_def = 0;
unsigned char dRendering_def = 0;
bool GUI_DoubleBuffered_def = FALSE;
DWORD GUI_PriorityClass_def = NORMAL_PRIORITY_CLASS;
int GUI_ThreadPriority_def = THREAD_PRIORITY_NORMAL;

bool8 SupportHiResFlag_def = TRUE;
bool8 Settings_Mode7Interpolate_def = FALSE;
bool8 Settings_SixteenBit_def = TRUE;
bool8 TransparencyFlag_def = 1;
bool8 Settings_BGLayering_def = FALSE;
bool8 Settings_DisableGraphicWindows_def = FALSE;
bool8 Settings_DisableHDMA_def = FALSE;
bool8 Settings_InterpolatedSound_def = TRUE;
bool8 Settings_DisableSampleCaching_def = FALSE;
// bool8 Settings_AltSampleDecode_def = 2;
bool8 Settings_AltSampleDecode_def = 5; // Original
bool8 Settings_NextAPUEnabled_def = TRUE;
bool8 Settings_DisableSoundEcho_def = FALSE;
bool8 Settings_ReverseStereo_def = FALSE;
bool8 Settings_SoundSync_def = TRUE;
bool8 Settings_DisableMasterVolume_def = FALSE;
bool8 Settings_SoundEnvelopeHeightReading_def = TRUE;
uint8 Settings_SoundSkipMethod_def = 0;
bool8 Settings_ShutdownMaster_def = TRUE;
uint32 Settings_ControllerOption_def = SNES_JOYPAD;
bool8 Settings_MultiPlayer5_def = TRUE;
bool8 Settings_Mouse_def = TRUE;
bool8 Settings_SuperScope_def = TRUE;
bool8 Settings_Justifier_def = TRUE;
uint32 Settings_SkipFrames_def = AUTO_FRAMERATE;
uint32 Settings_AutoMaxSkipFrames_def = 10;
long Settings_CyclesPercentage_def = 100;
uint32 Settings_FrameTimePAL_def = 20;
uint32 Settings_FrameTimeNTSC_def = 16;
int32 Settings_AutoSaveDelay_def = 0;
bool8 Settings_SDD1Pack_def = TRUE;
bool8 Xppsystem_DisableIRQCycleCount_def = TRUE;
unsigned char GUI_FileBrowseWindow_def = TRUE;

void WinLoad( void)
{
//ftHgݒ
	DoubleRenderingModes16 = DoubleRenderingModes16_def;
	DoubleRenderingModes8 = DoubleRenderingModes8_def;
	ForceWindowedDirectDrawClipper = ForceWindowedDirectDrawClipper_def;
	dRendering = dRendering_def;
	TransparencyFlag = TransparencyFlag_def;

	DirectX_Initialize0();

	GUI.ScreenDepth = 16;
	GUI.Scale = 0;
	GUI.DoubleBuffered = GUI_DoubleBuffered_def;
	GUI.PauseEmulation = FALSE;
	GUI.ForcedPauseEmulation = FALSE;
	GUI.FullScreen = FALSE;
	GUI.Stretch = FALSE;

	//LangID 0x0411 {
	Options.JPenvFlag = (GetSystemDefaultLangID() == 0x0411 ? 1 : 0);
	GUI.Language = (GetSystemDefaultLangID() == 0x0411 ? 1 : 0);
	Settings.DisplayFrameRate = FALSE;

	Settings.SixteenBit = Settings_SixteenBit_def;
	Settings.Transparency = TransparencyFlag_def;
	SupportHiResFlag = SupportHiResFlag_def;
	Settings.SupportHiRes = FALSE;
	Settings.SkipFrames = Settings_SkipFrames_def;


    // CPU options 
    Settings.NextAPUEnabled = Settings_NextAPUEnabled_def;
	Settings.ShutdownMaster = Settings_ShutdownMaster_def;
    Settings.SoundSkipMethod = Settings_SoundSkipMethod_def;
    Settings.CyclesPercentage = Settings_CyclesPercentage_def;
    Settings.H_Max = SNES_CYCLES_PER_SCANLINE;
    Settings.HBlankStart = (256 * Settings.H_Max) / SNES_HCOUNTER_MAX;

//    Settings.SPCTo65c816Ratio = 2;
    Settings.DisableIRQ = FALSE;
    Settings.Paused = FALSE;

    // Tracing options
    Settings.TraceDMA = FALSE;
    Settings.TraceHDMA = FALSE;
    Settings.TraceVRAM = FALSE;
    Settings.TraceUnknownRegisters = FALSE;
    Settings.TraceDSP = FALSE;

    // Joystick options
    Settings.SwapJoypads = FALSE;
    Settings.JoystickEnabled = TRUE;

    // ROM timing options (see also H_Max above)
    Settings.PAL = FALSE;
    Settings.FrameTimePAL = Settings_FrameTimePAL_def;
    Settings.FrameTimeNTSC = Settings_FrameTimeNTSC_def;
    Settings.FrameTime = Settings_FrameTimeNTSC_def;

    // ROM image and peripheral options
	Settings.ForceHiROM = FALSE;
	Settings.ForceLoROM = FALSE;
	Settings.ForceInterleaved = FALSE;
	Settings.ForceNotInterleaved = FALSE;
	Settings.ForceInterleaved2 = FALSE;
	Settings.ForcePAL = FALSE;
	Settings.ForceNTSC = FALSE;
	Settings.ForceHeader = FALSE;
	Settings.ForceNoHeader = FALSE;
    Settings.ForceSuperFX = FALSE;
    Settings.ForceNoSuperFX = FALSE;
	Settings.ForceDSP1 = FALSE;
	Settings.ForceNoDSP1 = FALSE;

    Settings.Mouse = Settings_Mouse_def;
    Settings.SuperScope = Settings_SuperScope_def;
    Settings.MultiPlayer5 = Settings_MultiPlayer5_def;
    Settings.ControllerOption = Settings_ControllerOption_def;
    Settings.Justifier = Settings_Justifier_def;

    // Sound options
    Settings.TraceSoundDSP = FALSE;
    Settings.SoundPlaybackRate = 32000;
	GUI.SoundMode = GUI_SoundMode_def;
	Settings.Mute = FALSE;

	Settings.ReverseStereo = Settings_ReverseStereo_def;
//    Settings.Stereo = _stereo;
//    Settings.SoundBufferSize = _bytecount;
    Settings.SoundEnvelopeHeightReading = Settings_SoundEnvelopeHeightReading_def;
    Settings.DisableSoundEcho = Settings_DisableSoundEcho_def;
	Settings.DisableMasterVolume = Settings_DisableMasterVolume_def;
	Settings.DisableSampleCaching = Settings_DisableSampleCaching_def;
    Settings.InterpolatedSound = Settings_InterpolatedSound_def;
	Settings.AltSampleDecode = Settings_AltSampleDecode_def;
	Settings.SoundMixInterval = Settings_SoundMixInterval_def;
    Settings.SoundBufferSize = Settings_SoundBufferSize_def;
    Settings.SoundSync = Settings_SoundSync_def;
	Settings.ThreadSound = FALSE;

    // SNES graphics options
    Settings.BGLayering = Settings_BGLayering_def;
    Settings.DisableGraphicWindows = Settings_DisableGraphicWindows_def;
    Settings.ForceTransparency = FALSE;
    Settings.ForceNoTransparency = FALSE;
    Settings.DisableHDMA = Settings_DisableHDMA_def;
    Settings.Mode7Interpolate = Settings_Mode7Interpolate_def;

//    Settings.AutoSaveDelay = 0;
    Settings.AutoSaveDelay = Settings_AutoSaveDelay_def;

    Settings.ApplyCheats = FALSE;
    Settings.TurboMode = FALSE;
    Settings.TurboSkipFrames = 15;
    Settings.AutoMaxSkipFrames = Settings_AutoMaxSkipFrames_def;

    Settings.SDD1Pack = Settings_SDD1Pack_def;
    Xppsystem.DisableIRQCycleCount = Xppsystem_DisableIRQCycleCount_def;

    Settings.NetPlay = FALSE;
    Settings.ServerName [0] = 0;

	GUI.PriorityClass = GUI_PriorityClass_def;
	GUI.ThreadPriority = GUI_ThreadPriority_def;

	GUI.FileBrowseWindow = GUI_FileBrowseWindow_def;

	//ݒt@Cǂݍ
	ReadIniFile();
	if(!Options.JPenvFlag)
		GUI.Language = 0;
	if (Settings.SixteenBit)
		Settings.Transparency = TransparencyFlag;
	else
		Settings.Transparency = FALSE;

	if(!dRendering)
		DirectX.ForceWindowedDirectDrawClipper = ForceWindowedDirectDrawClipper;
	else
		DirectX.ForceWindowedDirectDrawClipper = FALSE;

	CurFullscreenDisplayModeIndexChange();

	//Check MMX CPU
	mmx_cpu = IsMMXEnabled();
	SelectRenderingCodes();
	MakeTurboStatus();

	//Switch GFXengine
	S9xSwitchGFXengine(Options.GFXengine2);
}

/* ROMLoadProc */
static bool ROMLoadProc(char *FileName)
{
	extern void RemoveFileName(char *PathStr);
	char *eext;

	//GetOpenFileNamê߂̃t@Cݒ
	lstrcpy(InitialROMFileDirectory, FileName);
	RemoveFileName(InitialROMFileDirectory);
	lstrcpy(FileTitle, S9xBasename((const char *)FileName));
	if(FileName != ROMFileName)
		lstrcpy(ROMFileName, FileName);

	if( !GUI.StopEmulation && EmuExecLoop == S9xMainLoop) {
		Memory.SaveSRAM( S9xGetFilename(".srm"));
		S9xSaveCheatFile(S9xGetFilename(".cht"));
              if(Xppcdda.Enable) cdda_exit(); // Original
              XPP_REPLAY_END ();
	}
	eext = GetFilenameExt(FileName);
	if((!lstrcmp(eext, ".spc") || !lstrcmp(eext, ".sp1") || !lstrcmp(eext, ".sp2") || !lstrcmp(eext, ".sp3") || !lstrcmp(eext, ".sp4") ||
		!lstrcmp(eext, ".sp5") || !lstrcmp(eext, ".sp6") || !lstrcmp(eext, ".sp7") || !lstrcmp(eext, ".sp8") || !lstrcmp(eext, ".sp9"))) {

		//[W^CvwNA
		Settings.ForceLoROM = Settings.ForceHiROM = 0;
		Settings.ForceInterleaved = Settings.ForceInterleaved2 = Settings.ForceNotInterleaved = 0;
		Settings.ForcePAL = Settings.ForceNTSC = 0;
		Settings.ForceHeader = Settings.ForceNoHeader = 0;

		GUI.StopEmulation = LoadSPC(ROMFileName);
		if(!GUI.StopEmulation) {
			EmuExecLoop = SPCPlayMainLoop;
			SPCLoadedFlag = SPCPlayingFlag = TRUE;
			GUI.FullScreen = FALSE;
			S9xwSetMenuStatus(GUI.hMenu, GUI.hSysMenu);
			DirectX.ForceClipper = TRUE;
			S9xDrawScreenImage();
			ScreenRedraw(GUI.hWnd);
			return TRUE;
		}
		else {
			GUI.FullScreen = FALSE;
			S9xwSetMenuStatus(GUI.hMenu, GUI.hSysMenu);
			DirectX.ForceClipper = TRUE;
			S9xDrawScreenImage();
			ScreenRedraw(GUI.hWnd);
			return FALSE;
		}
	}

/*
	Memory.Deinit ();
	S9xDeinitAPU ();
	if(!Memory.Init () || !S9xInitAPU ())
		DirectX.ForceClipper = FALSE;
		return FALSE;
*/
	GUI.StopEmulation = !Memory.LoadROM( FileName);

	//[W^CvwNA
	Settings.ForceLoROM = Settings.ForceHiROM = 0;
	Settings.ForceInterleaved = Settings.ForceInterleaved2 = Settings.ForceNotInterleaved = 0;
	Settings.ForcePAL = Settings.ForceNTSC = 0;
	Settings.ForceHeader = Settings.ForceNoHeader = 0;

	if( !GUI.StopEmulation) {
		Memory.LoadSRAM(S9xGetFilename(".srm"));

 // Original
if(Xppcdda.Enable)
{
		cdda_open();
		cdda_stop();
}

#ifdef UNCO_FULL_TEAM
if(Xppbsx.BsxRomCheck) {
BSX_CLEAR ();
BSX_SRAMFIRST ();
}
#endif

XPP_ROMCHEAT_CODE (ROMCHEAT_CLEAR); // Original
		EmuExecLoop = S9xMainLoop;
		SPCPlayingFlag = FALSE;
	}
	else {
		S9xwSetMenuStatus(GUI.hMenu, GUI.hSysMenu);
		DirectX.ForceClipper = FALSE;
		return FALSE;
	}
	//256FfXNgbv̂Ƃ͋IɃtXN[
	if(DirectX.Windowed && DirectX.Depth == 8)
		GUI.FullScreen = TRUE;
	//XN[obt@NA
	ScreenBufferClear();
	//tXN[[hŃǂݍ񂾂Ƃ̏
	if(GUI.FullScreen && DirectX.Windowed)
	{
		if(!S9xwSwitchScreenMode(FALSE)) {
			DirectX.ForceClipper = FALSE;
			return FALSE;
		}
	}
// wp`R̕sC
        else
        {
		if(!GUI.StopEmulation && !SPCPlayingFlag) {
			for (int c = 0; c < 256; c++)
				IPPU.ScreenColors [c] = c;
			S9xFixColourBrightness ();
			IPPU.ColorsChanged = TRUE;
			IPPU.RenderThisFrame = FALSE;
		}
        }

	S9xwSetMenuStatus(GUI.hMenu, GUI.hSysMenu);
	DirectX.ForceClipper = FALSE;
	return TRUE;
}

void S9xSetWindowPos()
{
	SetWindowPos(GUI.hWnd, HWND_TOP, WindowRectSetting.left, WindowRectSetting.top, 
		WindowRectSetting.right - WindowRectSetting.left, WindowRectSetting.bottom - WindowRectSetting.top, SWP_DRAWFRAME|SWP_FRAMECHANGED);
}

void Draw1frame()
{
	if(GUI.StopEmulation || SPCPlayingFlag)
		return;
	int Width = 256;
	int Height = ExtendHeight ? 239 : 224;
	if(DoubleWidth)
		Width <<= 1;
	if(DoubleHeight)
		Height <<= 1;
	S9xDeinitUpdate(Width, Height, Settings.SixteenBit);
}

void ScreenRedraw(HWND hWnd)
{
	RECT srcRect, dstRect;
	POINT p;
	long SrcHeight = ExtendHeight ? 239 : 224;
	long SrcWidth = 256;
	long DstHeight = ExtendHeight ? 239 : 224;
	long DstWidth = 256;

	hdc=BeginPaint(hWnd,&ps);
	EndPaint(hWnd,&ps);

	if(DoubleHeight || (GUI.Scale > 1 && !DoubleWidth && !DoubleHeight) || (GUI.Scale > 1 && DoubleWidth && !DoubleHeight && DirectX.DisableHardwareScale))
		SrcHeight <<= 1;
	if(DoubleWidth || (GUI.Scale > 1 && !DoubleWidth && !DoubleHeight) || (GUI.Scale > 1 && !DoubleWidth && DoubleHeight && DirectX.DisableHardwareScale))
		SrcWidth <<= 1;
	if(GUI.Scale > 0)
		DstHeight <<= 1;
	if(GUI.Scale > 0)
		DstWidth <<= 1;
	if(locked_surface)
	{
		srcRect.top    = 0;
		srcRect.left   = 0;
	}
	else
	{
		srcRect.top    = (478 - SrcHeight) / 2;
		srcRect.left   = (512 - SrcWidth) / 2;
	}
	srcRect.right  = srcRect.left + SrcWidth;
	srcRect.bottom = srcRect.top  + SrcHeight;
	
	GetClientRect(hWnd, &dstRect);
	if(GUI.Stretch)
	{
		p.x = 0;
		p.y = 0;
		ClientToScreen (hWnd, &p);
		DstWidth = dstRect.right - dstRect.left;
		DstHeight = dstRect.bottom - dstRect.top;
		dstRect.top = p.y;
		dstRect.left = p.x;
		dstRect.bottom = dstRect.top + DstHeight;
		dstRect.right  = dstRect.left + DstWidth;
	}
	else
	{
		p.x = ((dstRect.right - dstRect.left) - DstWidth) / 2;
		p.y = ((dstRect.bottom - dstRect.top) - DstHeight) / 2;
		ClientToScreen (hWnd, &p);
		dstRect.top = p.y;
		dstRect.left = p.x;
		dstRect.bottom = dstRect.top + DstHeight;
		dstRect.right  = dstRect.left + DstWidth;
	}
	if(!DirectX.lpDDSPrimary2 && DirectX.lpDDSPrimary) {
		if(DirectX.wait_for_vsync)
			DirectX.lpDD->WaitForVerticalBlank(DDWAITVB_BLOCKBEGIN,0);
		DirectX.lpDDSPrimary -> Blt( &dstRect, DirectX.lpDDSOffScreen, &srcRect, DDBLT_WAIT, NULL);
	}
	else if(DirectX.lpDDSPrimary2 && !DirectX.lpDDSPrimary) {
		if(DirectX.wait_for_vsync)
			DirectX.lpDD->WaitForVerticalBlank(DDWAITVB_BLOCKBEGIN,0);
		DirectX.lpDDSPrimary2 -> Blt( &dstRect, DirectX.lpDDSOffScreen2, &srcRect, DDBLT_WAIT, NULL);
	}
}

void SetPriorityClassAndThreadPriority(DWORD priocl, int threadprio)
{
	SetPriorityClass(GetCurrentProcess(), priocl);
	SetThreadPriority(GetCurrentThread(), threadprio);
}

volatile unsigned long LastSound = 0;
static HANDLE hFrameTimerSemaphore;

VOID CALLBACK FrameTimer( UINT idEvent, UINT uMsg, DWORD dwUser, DWORD dw1, DWORD dw2)
{
	static unsigned long Xpp_NtscCount = 0;
	int temp_timer;
	int Xpp_NtscCycle [6] = {16, 17, 17, 16, 17, 17};

	if( GUI.hFrameTimer != idEvent)
	{	return;	}

	if( timeGetTime() < GUI.FrameTimerStart);
	else {
		if(Settings.FrameTime == 16) {
			temp_timer = Settings.FrameTime;
			if(Xpp_NtscCount >= 6) Xpp_NtscCount = 0;
			Settings.FrameTime = Xpp_NtscCycle [Xpp_NtscCount];
			GUI.FrameTimerStart = GUI.FrameTimerStart + Settings.FrameTime;
			++Xpp_NtscCount;
			Settings.FrameTime = temp_timer;
		}
		else
			GUI.FrameTimerStart = GUI.FrameTimerStart + Settings.FrameTime;

		if( GUI.PauseEmulation || GUI.StopEmulation || GUI.ForcedPauseEmulation) {
			WaitForSingleObject (hFrameTimerSemaphore, 0);
		}
		else {
			ReleaseSemaphore (hFrameTimerSemaphore, 1, NULL);
		}
	}
	while( (timeGetTime() - LastSound) >= _interval)
	{
		LastSound += _interval;

		void ProcessSound( void);
		ProcessSound();
	}
	return;
}

/*****************************************************************************/
/* WinMain                                                                   */
/*****************************************************************************/


int WINAPI WinMain( 
	HINSTANCE hInstance,
	HINSTANCE hPrevInstance,
	LPSTR lpCmdLine,
	int nCmdShow)
{
	MSG msg;
	HACCEL hAccel;
	DWORD wSoundTimerRes = 0;
	EmuExecLoop = S9xMainLoop;

    FillMemory ((PVOID)&Settings, sizeof (Settings), 0);
    FillMemory ((PVOID)&GUI, sizeof (GUI), 0);

//	SetThreadPriority(GetCurrentThread(), THREAD_PRIORITY_HIGHEST);

	GUI.StopEmulation = true;

	GUI.dwStyleWindowed = WS_OVERLAPPED | WS_CAPTION | WS_SYSMENU | WS_MINIMIZEBOX | WS_MAXIMIZEBOX | WS_VISIBLE | WS_THICKFRAME;
	GUI.dwStyleFullScreen = WS_POPUP|WS_VISIBLE;

	//256x239̃EChETCYvZ
	SetRect(&rc, 0, 0, 256, 239);
	AdjustWindowRect(&rc, GUI.dwStyleWindowed, TRUE);
	DefaultWindowSizeW = rc.right - rc.left;
	DefaultWindowSizeH = rc.bottom - rc.top;

	//512x478̃EChETCYvZ
	SetRect(&rc, 0, 0, 512, 478);
	AdjustWindowRect(&rc, GUI.dwStyleWindowed, TRUE);
	DefaultWindowSizeWW[0] = rc.right - rc.left;
	DefaultWindowSizeHH[0] = rc.bottom - rc.top;

	//512x384̃EChETCYvZ
	SetRect(&rc, 0, 0, 512, 384);
	AdjustWindowRect(&rc, GUI.dwStyleWindowed, TRUE);
	DefaultWindowSizeWW[1] = rc.right - rc.left;
	DefaultWindowSizeHH[1] = rc.bottom - rc.top;

	//768x576̃EChETCYvZ
	SetRect(&rc, 0, 0, 768, 576);
	AdjustWindowRect(&rc, GUI.dwStyleWindowed, TRUE);
	DefaultWindowSizeWW[2] = rc.right - rc.left;
	DefaultWindowSizeHH[2] = rc.bottom - rc.top;

	//768x717̃EChETCYvZ
	SetRect(&rc, 0, 0, 768, 717);
	AdjustWindowRect(&rc, GUI.dwStyleWindowed, TRUE);
	DefaultWindowSizeWW[3] = rc.right - rc.left;
	DefaultWindowSizeHH[3] = rc.bottom - rc.top;

	//1024x768̃EChETCYvZ
	SetRect(&rc, 0, 0, 1024, 768);
	AdjustWindowRect(&rc, GUI.dwStyleWindowed, TRUE);
	DefaultWindowSizeWW[4] = rc.right - rc.left;
	DefaultWindowSizeHH[4] = rc.bottom - rc.top;

	//1024x956̃EChETCYvZ
	SetRect(&rc, 0, 0, 1024, 956);
	AdjustWindowRect(&rc, GUI.dwStyleWindowed, TRUE);
	DefaultWindowSizeWW[5] = rc.right - rc.left;
	DefaultWindowSizeHH[5] = rc.bottom - rc.top;

	//1024x956̃EChETCYvZ
	SetRect(&rc, 0, 0, 1536, 1152);
	AdjustWindowRect(&rc, GUI.dwStyleWindowed, TRUE);
	DefaultWindowSizeWW[6] = rc.right - rc.left;
	DefaultWindowSizeHH[6] = rc.bottom - rc.top;

	WinLoad();
	WinInit( hInstance);

	if( !DirectX_Initialize(GUI.hWnd, GUI.dwStyleWindowed, GUI.dwStyleFullScreen))
	{
		MessageBox( GUI.hWnd, Languages[ GUI.Language].errInitDD, "Snes9X - DirectX", MB_OK | MB_ICONSTOP);
		return false; 
	}
	
	if( !DirectX_SetDisplayMode(DisplayMode[CurFullscreenDisplayModeIndex].Width, DisplayMode[CurFullscreenDisplayModeIndex].Height, DisplayMode[CurFullscreenDisplayModeIndex].Depth, TRUE, GUI.DoubleBuffered))
	{
		MessageBox( GUI.hWnd, Languages[ GUI.Language].errModeDD, "Snes9X - DirectDraw", MB_OK | MB_ICONSTOP);
		DirectX_DeInitialize();
		return false; 
	}
	GUI.ScreenDepth = (DWORD)DirectX.Depth;

	if( GUI.SoundMode == -1)
	{	SetupSound( 0, false, false);	}
	else
	if( !SetupSound( SoundRates[GUI.SoundMode].rate, SoundRates[GUI.SoundMode].sixteen_bit, SoundRates[GUI.SoundMode].stereo))
	{	MessageBox( GUI.hWnd, Languages[ GUI.Language].errInitDS, "Snes9X - DirectSound", MB_OK | MB_ICONINFORMATION);	}

//	GUI.StopEmulation = true;
	
	TIMECAPS tc;
	if( timeGetDevCaps(&tc, sizeof(TIMECAPS))== TIMERR_NOERROR)
	{
		wSoundTimerRes = tc.wPeriodMin;
		timeBeginPeriod( wSoundTimerRes);
	}

	LastSound = GUI.FrameTimerStart = timeGetTime();
	GUI.FrameTimerStart += Settings.FrameTime;

	hFrameTimerSemaphore = GUI.FrameTimerSemaphore = CreateSemaphore(NULL, 0, 10, "uosnes - FrameTimerSemaphore");
	if( GUI.FrameTimerSemaphore)
	{
		GUI.hFrameTimer = timeSetEvent(wSoundTimerRes, 0, &FrameTimer, 0, TIME_PERIODIC);
		if(!GUI.hFrameTimer)
		{
			CloseHandle( GUI.FrameTimerSemaphore);
			GUI.FrameTimerSemaphore = 0;
		}
	}

	if( !GUI.hFrameTimer || !GUI.FrameTimerSemaphore)
	{
		MessageBox( GUI.hWnd, Languages[ GUI.Language].errFrameTimer, "Snes9X - Frame Timer", MB_OK | MB_ICONINFORMATION);
	}

	if(!InitSnes9X())
		S9xExitFlag = 1;

	hAccel = LoadAccelerators(hInstance, MAKEINTRESOURCE(AACCEL));

	while( TRUE)
	{
              while (GUI.StopEmulation || GUI.PauseEmulation ||
                     GUI.ForcedPauseEmulation ||
                PeekMessage( &msg, NULL, 0, 0, PM_NOREMOVE))
		{
			if( !GetMessage( &msg, NULL, 0, 0))
                    goto loop_exit;
			if (!TranslateAccelerator(GUI.hWnd, hAccel, &msg)) {
				TranslateMessage(&msg);
				DispatchMessage(&msg);
			}
		}

		if( !GUI.StopEmulation && !GUI.PauseEmulation && !GUI.ForcedPauseEmulation)
			EmuExecLoop();
	}

loop_exit:

	if( GUI.hFrameTimer)
		timeKillEvent( GUI.hFrameTimer);
	if( GUI.FrameTimerSemaphore)
		CloseHandle( GUI.FrameTimerSemaphore);
	if(wSoundTimerRes)
		timeEndPeriod( wSoundTimerRes);

	if( !GUI.StopEmulation && EmuExecLoop == S9xMainLoop) {
		Memory.SaveSRAM( S9xGetFilename(".srm"));
		S9xSaveCheatFile(S9xGetFilename(".cht"));
              if(Xppcdda.Enable) cdda_exit(); // Original
              XPP_REPLAY_END ();
	}
	WinSave();

/* Ǐn */
	DeinitSnes9X();

//	SetThreadPriority(GetCurrentThread(), THREAD_PRIORITY_NORMAL);

	return msg.wParam;
}

/*****************************************************************************/
